/* sudoku-view.c generated by valac 0.56.17, the Vala compiler
 * generated from sudoku-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 * Copyright © 2023 Jamie Murphy <jmurphy@gnome.org>
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <adwaita.h>
#include <glib-object.h>
#include <glib.h>
#include "libsudoku.h"
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
typedef struct _SudokuViewPrivate SudokuViewPrivate;

#define TYPE_SUDOKU_CELL (sudoku_cell_get_type ())
#define SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL, SudokuCell))
#define SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL, SudokuCellClass))
#define IS_SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL))
#define IS_SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL))
#define SUDOKU_CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL, SudokuCellClass))

typedef struct _SudokuCell SudokuCell;
typedef struct _SudokuCellClass SudokuCellClass;

#define TYPE_SUDOKU_FRAME (sudoku_frame_get_type ())
#define SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_FRAME, SudokuFrame))
#define SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_FRAME, SudokuFrameClass))
#define IS_SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_FRAME))
#define IS_SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_FRAME))
#define SUDOKU_FRAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_FRAME, SudokuFrameClass))

typedef struct _SudokuFrame SudokuFrame;
typedef struct _SudokuFrameClass SudokuFrameClass;
enum  {
	SUDOKU_VIEW_0_PROPERTY,
	SUDOKU_VIEW_SELECTED_ROW_PROPERTY,
	SUDOKU_VIEW_SELECTED_COL_PROPERTY,
	SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SIMPLE_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY,
	SUDOKU_VIEW_HIGHLIGHTER_PROPERTY,
	SUDOKU_VIEW_HAS_SELECTION_PROPERTY,
	SUDOKU_VIEW_NUM_PROPERTIES
};
static GParamSpec* sudoku_view_properties[SUDOKU_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
enum  {
	SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL,
	SUDOKU_VIEW_NUM_SIGNALS
};
static guint sudoku_view_signals[SUDOKU_VIEW_NUM_SIGNALS] = {0};

struct _SudokuView {
	AdwBin parent_instance;
	SudokuViewPrivate * priv;
	gboolean earmark_mode;
	gboolean autoclean_earmarks;
	gboolean number_picker_second_click;
	gboolean highlight_row_column;
	gboolean highlight_block;
	gboolean highlight_numbers;
};

struct _SudokuViewClass {
	AdwBinClass parent_class;
};

struct _SudokuViewPrivate {
	SudokuGame* game;
	SudokuCell** cells;
	gint cells_length1;
	gint cells_length2;
	SudokuFrame* frame;
	GtkLabel* paused_label;
	gint _selected_row;
	gint _selected_col;
	gboolean _show_warnings;
	gboolean _show_earmark_warnings;
	gboolean _simple_warnings;
	gboolean _show_possibilities;
	gboolean _highlighter;
	gboolean _has_selection;
};

static gint SudokuView_private_offset;
static gpointer sudoku_view_parent_class = NULL;

VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
VALA_EXTERN GType sudoku_cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCell, g_object_unref)
VALA_EXTERN GType sudoku_frame_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuFrame, g_object_unref)
VALA_EXTERN void sudoku_view_set_selected (SudokuView* self,
                               gint cell_row,
                               gint cell_col);
VALA_EXTERN gint sudoku_view_get_selected_row (SudokuView* self);
VALA_EXTERN gint sudoku_view_get_selected_col (SudokuView* self);
VALA_EXTERN void sudoku_cell_set_selected (SudokuCell* self,
                               gboolean value);
static void sudoku_view_set_selected_row (SudokuView* self,
                                   gint value);
static void sudoku_view_set_selected_col (SudokuView* self,
                                   gint value);
VALA_EXTERN SudokuView* sudoku_view_new (SudokuGame* game,
                             GSettings* settings);
VALA_EXTERN SudokuView* sudoku_view_construct (GType object_type,
                                   SudokuGame* game,
                                   GSettings* settings);
VALA_EXTERN SudokuFrame* sudoku_frame_new (GtkWidget* child);
VALA_EXTERN SudokuFrame* sudoku_frame_construct (GType object_type,
                                     GtkWidget* child);
static void __lambda8_ (SudokuView* self);
static void sudoku_view_mask_view (SudokuView* self);
static void sudoku_view_clear_all_warnings (SudokuView* self);
static void sudoku_view_unmask_view (SudokuView* self);
static void sudoku_view_update_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_has_selection (SudokuView* self,
                                    gboolean value);
static void ___lambda8__sudoku_game_paused_changed (SudokuGame* _sender,
                                             gpointer self);
VALA_EXTERN SudokuCell* sudoku_cell_new (gint row,
                             gint col,
                             SudokuGame* game,
                             SudokuView* view);
VALA_EXTERN SudokuCell* sudoku_cell_construct (GType object_type,
                                   gint row,
                                   gint col,
                                   SudokuGame* game,
                                   SudokuView* view);
VALA_EXTERN void sudoku_cell_get_visible_earmarks (SudokuCell* self);
static void sudoku_view_cell_changed_cb (SudokuView* self,
                                  gint row,
                                  gint col,
                                  gint old_val,
                                  gint new_val);
static void _sudoku_view_cell_changed_cb_sudoku_board_cell_changed (SudokuBoard* _sender,
                                                             gint row,
                                                             gint col,
                                                             gint old_val,
                                                             gint new_val,
                                                             gpointer self);
static void sudoku_view_earmark_changed_cb (SudokuView* self,
                                     gint row,
                                     gint col,
                                     gint num,
                                     gboolean enabled);
static void _sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed (SudokuBoard* _sender,
                                                                   gint row,
                                                                   gint col,
                                                                   gint num,
                                                                   gboolean enabled,
                                                                   gpointer self);
static void sudoku_view_selection_changed_cb (SudokuView* self,
                                       gint old_row,
                                       gint old_col,
                                       gint new_row,
                                       gint new_col);
static void _sudoku_view_selection_changed_cb_sudoku_view_selection_changed (SudokuView* _sender,
                                                                      gint old_row,
                                                                      gint old_col,
                                                                      gint new_row,
                                                                      gint new_col,
                                                                      gpointer self);
VALA_EXTERN gboolean sudoku_view_get_show_possibilities (SudokuView* self);
static void sudoku_view_set_cell_highlighter (SudokuView* self,
                                       gint row,
                                       gint col,
                                       gboolean enabled);
VALA_EXTERN void sudoku_cell_dismiss_popover (SudokuCell* self);
VALA_EXTERN void sudoku_cell_update_value (SudokuCell* self);
static void sudoku_view_set_value_highlighter (SudokuView* self,
                                        gint val,
                                        gboolean enabled);
VALA_EXTERN void sudoku_cell_get_visible_earmark (SudokuCell* self,
                                      gint num);
VALA_EXTERN gboolean sudoku_view_get_show_warnings (SudokuView* self);
VALA_EXTERN void sudoku_cell_check_earmark_warnings (SudokuCell* self,
                                         gint num);
VALA_EXTERN gboolean sudoku_view_get_highlighter (SudokuView* self);
VALA_EXTERN gint sudoku_cell_get_value (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_value (SudokuCell* self,
                                        gboolean value);
VALA_EXTERN void sudoku_cell_set_earmark_highlight (SudokuCell* self,
                                        gint val,
                                        gboolean enabled);
VALA_EXTERN gboolean sudoku_cell_get_is_fixed (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_background (SudokuCell* self,
                                             gboolean value);
VALA_EXTERN void sudoku_cell_check_value_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_cell_check_earmarks_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_cell_clear_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_paused (SudokuCell* self,
                             gboolean value);
VALA_EXTERN void sudoku_view_dismiss_popovers (SudokuView* self);
static void sudoku_view_real_dispose (GObject* base);
VALA_EXTERN void sudoku_view_set_show_warnings (SudokuView* self,
                                    gboolean value);
VALA_EXTERN gboolean sudoku_view_get_show_earmark_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_earmark_warnings (SudokuView* self,
                                            gboolean value);
VALA_EXTERN gboolean sudoku_view_get_simple_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_simple_warnings (SudokuView* self,
                                      gboolean value);
VALA_EXTERN void sudoku_view_set_show_possibilities (SudokuView* self,
                                         gboolean value);
VALA_EXTERN void sudoku_view_set_highlighter (SudokuView* self,
                                  gboolean value);
VALA_EXTERN gboolean sudoku_view_get_has_selection (SudokuView* self);
static void g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data);
static gboolean _sudoku_view___lambda9_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda9__gtk_shortcut_func (GtkWidget* widget,
                                                     GVariant* args,
                                                     gpointer self);
static gboolean _sudoku_view___lambda10_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda10__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda11_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda11__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda12_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda12__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static void sudoku_view_finalize (GObject * obj);
static GType sudoku_view_get_type_once (void);
static void _vala_sudoku_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sudoku_view_get_instance_private (SudokuView* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuView_private_offset);
}

void
sudoku_view_set_selected (SudokuView* self,
                          gint cell_row,
                          gint cell_col)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gboolean _tmp3_ = FALSE;
	gint _tmp4_;
	gint old_row = 0;
	gint _tmp10_;
	gint old_col = 0;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gboolean _tmp14_ = FALSE;
	gint _tmp15_;
#line 45 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->_selected_row;
#line 47 "../src/sudoku-view.vala"
	if (_tmp1_ == cell_row) {
#line 332 "sudoku-view.c"
		gint _tmp2_;
#line 47 "../src/sudoku-view.vala"
		_tmp2_ = self->priv->_selected_col;
#line 47 "../src/sudoku-view.vala"
		_tmp0_ = _tmp2_ == cell_col;
#line 338 "sudoku-view.c"
	} else {
#line 47 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 342 "sudoku-view.c"
	}
#line 47 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 48 "../src/sudoku-view.vala"
		return;
#line 348 "sudoku-view.c"
	}
#line 50 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->_selected_row;
#line 50 "../src/sudoku-view.vala"
	if (_tmp4_ >= 0) {
#line 354 "sudoku-view.c"
		gint _tmp5_;
#line 50 "../src/sudoku-view.vala"
		_tmp5_ = self->priv->_selected_col;
#line 50 "../src/sudoku-view.vala"
		_tmp3_ = _tmp5_ >= 0;
#line 360 "sudoku-view.c"
	} else {
#line 50 "../src/sudoku-view.vala"
		_tmp3_ = FALSE;
#line 364 "sudoku-view.c"
	}
#line 50 "../src/sudoku-view.vala"
	if (_tmp3_) {
#line 368 "sudoku-view.c"
		SudokuCell** _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		gint _tmp7_;
		gint _tmp8_;
		SudokuCell* _tmp9_;
#line 51 "../src/sudoku-view.vala"
		_tmp6_ = self->priv->cells;
#line 51 "../src/sudoku-view.vala"
		_tmp6__length1 = self->priv->cells_length1;
#line 51 "../src/sudoku-view.vala"
		_tmp6__length2 = self->priv->cells_length2;
#line 51 "../src/sudoku-view.vala"
		_tmp7_ = self->priv->_selected_row;
#line 51 "../src/sudoku-view.vala"
		_tmp8_ = self->priv->_selected_col;
#line 51 "../src/sudoku-view.vala"
		_tmp9_ = _tmp6_[(_tmp7_ * _tmp6__length2) + _tmp8_];
#line 51 "../src/sudoku-view.vala"
		sudoku_cell_set_selected (_tmp9_, FALSE);
#line 389 "sudoku-view.c"
	}
#line 53 "../src/sudoku-view.vala"
	_tmp10_ = self->priv->_selected_row;
#line 53 "../src/sudoku-view.vala"
	old_row = _tmp10_;
#line 54 "../src/sudoku-view.vala"
	_tmp11_ = self->priv->_selected_col;
#line 54 "../src/sudoku-view.vala"
	old_col = _tmp11_;
#line 56 "../src/sudoku-view.vala"
	sudoku_view_set_selected_row (self, cell_row);
#line 57 "../src/sudoku-view.vala"
	sudoku_view_set_selected_col (self, cell_col);
#line 59 "../src/sudoku-view.vala"
	_tmp12_ = self->priv->_selected_row;
#line 59 "../src/sudoku-view.vala"
	_tmp13_ = self->priv->_selected_col;
#line 59 "../src/sudoku-view.vala"
	g_signal_emit (self, sudoku_view_signals[SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL], 0, old_row, old_col, _tmp12_, _tmp13_);
#line 61 "../src/sudoku-view.vala"
	_tmp15_ = self->priv->_selected_row;
#line 61 "../src/sudoku-view.vala"
	if (_tmp15_ >= 0) {
#line 413 "sudoku-view.c"
		gint _tmp16_;
#line 61 "../src/sudoku-view.vala"
		_tmp16_ = self->priv->_selected_col;
#line 61 "../src/sudoku-view.vala"
		_tmp14_ = _tmp16_ >= 0;
#line 419 "sudoku-view.c"
	} else {
#line 61 "../src/sudoku-view.vala"
		_tmp14_ = FALSE;
#line 423 "sudoku-view.c"
	}
#line 61 "../src/sudoku-view.vala"
	if (_tmp14_) {
#line 427 "sudoku-view.c"
		SudokuCell** _tmp17_;
		gint _tmp17__length1;
		gint _tmp17__length2;
		gint _tmp18_;
		gint _tmp19_;
		SudokuCell* _tmp20_;
#line 62 "../src/sudoku-view.vala"
		_tmp17_ = self->priv->cells;
#line 62 "../src/sudoku-view.vala"
		_tmp17__length1 = self->priv->cells_length1;
#line 62 "../src/sudoku-view.vala"
		_tmp17__length2 = self->priv->cells_length2;
#line 62 "../src/sudoku-view.vala"
		_tmp18_ = self->priv->_selected_row;
#line 62 "../src/sudoku-view.vala"
		_tmp19_ = self->priv->_selected_col;
#line 62 "../src/sudoku-view.vala"
		_tmp20_ = _tmp17_[(_tmp18_ * _tmp17__length2) + _tmp19_];
#line 62 "../src/sudoku-view.vala"
		sudoku_cell_set_selected (_tmp20_, TRUE);
#line 448 "sudoku-view.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 67 "../src/sudoku-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 457 "sudoku-view.c"
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
#line 98 "../src/sudoku-view.vala"
	return self ? pango_attr_list_ref (self) : NULL;
#line 465 "sudoku-view.c"
}

static void
__lambda8_ (SudokuView* self)
{
	PangoAttrList* attr_list = NULL;
	GtkLabel* _tmp0_;
	PangoAttrList* _tmp1_;
	PangoAttrList* _tmp2_;
	PangoAttrList* _tmp3_;
	PangoAttrList* _tmp5_;
	PangoAttribute* _tmp6_;
	GtkLabel* _tmp7_;
	PangoAttrList* _tmp8_;
	GtkLabel* _tmp9_;
	SudokuGame* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	SudokuGame* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	SudokuGame* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
#line 98 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->paused_label;
#line 98 "../src/sudoku-view.vala"
	_tmp1_ = gtk_label_get_attributes (_tmp0_);
#line 98 "../src/sudoku-view.vala"
	_tmp2_ = _pango_attr_list_ref0 (_tmp1_);
#line 98 "../src/sudoku-view.vala"
	attr_list = _tmp2_;
#line 99 "../src/sudoku-view.vala"
	_tmp3_ = attr_list;
#line 99 "../src/sudoku-view.vala"
	if (_tmp3_ == NULL) {
#line 502 "sudoku-view.c"
		PangoAttrList* _tmp4_;
#line 100 "../src/sudoku-view.vala"
		_tmp4_ = pango_attr_list_new ();
#line 100 "../src/sudoku-view.vala"
		_pango_attr_list_unref0 (attr_list);
#line 100 "../src/sudoku-view.vala"
		attr_list = _tmp4_;
#line 510 "sudoku-view.c"
	}
#line 102 "../src/sudoku-view.vala"
	_tmp5_ = attr_list;
#line 102 "../src/sudoku-view.vala"
	_tmp6_ = pango_attr_size_new_absolute (((gint) (gtk_widget_get_width ((GtkWidget*) self) * 0.125)) * PANGO_SCALE);
#line 102 "../src/sudoku-view.vala"
	pango_attr_list_change (_tmp5_, _tmp6_);
#line 106 "../src/sudoku-view.vala"
	_tmp7_ = self->priv->paused_label;
#line 106 "../src/sudoku-view.vala"
	_tmp8_ = attr_list;
#line 106 "../src/sudoku-view.vala"
	gtk_label_set_attributes (_tmp7_, _tmp8_);
#line 107 "../src/sudoku-view.vala"
	_tmp9_ = self->priv->paused_label;
#line 107 "../src/sudoku-view.vala"
	_tmp10_ = self->priv->game;
#line 107 "../src/sudoku-view.vala"
	_tmp11_ = sudoku_game_get_paused (_tmp10_);
#line 107 "../src/sudoku-view.vala"
	_tmp12_ = _tmp11_;
#line 107 "../src/sudoku-view.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp9_, _tmp12_);
#line 109 "../src/sudoku-view.vala"
	_tmp13_ = self->priv->game;
#line 109 "../src/sudoku-view.vala"
	_tmp14_ = sudoku_game_get_paused (_tmp13_);
#line 109 "../src/sudoku-view.vala"
	_tmp15_ = _tmp14_;
#line 109 "../src/sudoku-view.vala"
	if (_tmp15_) {
#line 111 "../src/sudoku-view.vala"
		sudoku_view_mask_view (self);
#line 112 "../src/sudoku-view.vala"
		sudoku_view_clear_all_warnings (self);
#line 546 "sudoku-view.c"
	} else {
#line 116 "../src/sudoku-view.vala"
		sudoku_view_unmask_view (self);
#line 117 "../src/sudoku-view.vala"
		sudoku_view_update_warnings (self);
#line 552 "sudoku-view.c"
	}
#line 120 "../src/sudoku-view.vala"
	_tmp16_ = self->priv->game;
#line 120 "../src/sudoku-view.vala"
	_tmp17_ = sudoku_game_get_paused (_tmp16_);
#line 120 "../src/sudoku-view.vala"
	_tmp18_ = _tmp17_;
#line 120 "../src/sudoku-view.vala"
	sudoku_view_set_has_selection (self, !_tmp18_);
#line 96 "../src/sudoku-view.vala"
	_pango_attr_list_unref0 (attr_list);
#line 564 "sudoku-view.c"
}

static void
___lambda8__sudoku_game_paused_changed (SudokuGame* _sender,
                                        gpointer self)
{
#line 96 "../src/sudoku-view.vala"
	__lambda8_ ((SudokuView*) self);
#line 573 "sudoku-view.c"
}

static void
_sudoku_view_cell_changed_cb_sudoku_board_cell_changed (SudokuBoard* _sender,
                                                        gint row,
                                                        gint col,
                                                        gint old_val,
                                                        gint new_val,
                                                        gpointer self)
{
#line 163 "../src/sudoku-view.vala"
	sudoku_view_cell_changed_cb ((SudokuView*) self, row, col, old_val, new_val);
#line 586 "sudoku-view.c"
}

static void
_sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed (SudokuBoard* _sender,
                                                              gint row,
                                                              gint col,
                                                              gint num,
                                                              gboolean enabled,
                                                              gpointer self)
{
#line 164 "../src/sudoku-view.vala"
	sudoku_view_earmark_changed_cb ((SudokuView*) self, row, col, num, enabled);
#line 599 "sudoku-view.c"
}

static void
_sudoku_view_selection_changed_cb_sudoku_view_selection_changed (SudokuView* _sender,
                                                                 gint old_row,
                                                                 gint old_col,
                                                                 gint new_row,
                                                                 gint new_col,
                                                                 gpointer self)
{
#line 165 "../src/sudoku-view.vala"
	sudoku_view_selection_changed_cb ((SudokuView*) self, old_row, old_col, new_row, new_col);
#line 612 "sudoku-view.c"
}

SudokuView*
sudoku_view_construct (GType object_type,
                       SudokuGame* game,
                       GSettings* settings)
{
	SudokuView * self = NULL;
	SudokuGame* _tmp0_;
	GameMode _tmp1_;
	GameMode _tmp2_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp3_;
	GtkOverlay* _tmp4_;
	SudokuFrame* _tmp5_;
	SudokuFrame* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkOverlay* _tmp10_;
	GtkLabel* _tmp11_;
	SudokuGame* _tmp12_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp13_ = NULL;
	GtkGrid* _tmp14_;
	GtkOverlay* _tmp15_;
	GtkGrid* _tmp16_;
	GtkGrid** blocks = NULL;
	SudokuBoard* _tmp17_;
	SudokuBoard* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	SudokuBoard* _tmp21_;
	SudokuBoard* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	GtkGrid** _tmp25_;
	gint blocks_length1;
	gint blocks_length2;
	SudokuBoard* _tmp49_;
	SudokuBoard* _tmp50_;
	gint _tmp51_;
	gint _tmp52_;
	SudokuBoard* _tmp53_;
	SudokuBoard* _tmp54_;
	gint _tmp55_;
	gint _tmp56_;
	SudokuCell** _tmp57_;
	SudokuGame* _tmp94_;
	SudokuBoard* _tmp95_;
	SudokuBoard* _tmp96_;
	SudokuGame* _tmp97_;
	SudokuBoard* _tmp98_;
	SudokuBoard* _tmp99_;
	gboolean _tmp100_ = FALSE;
	gboolean _tmp101_ = FALSE;
	gboolean _tmp102_;
	gboolean _tmp103_;
#line 65 "../src/sudoku-view.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 65 "../src/sudoku-view.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 65 "../src/sudoku-view.vala"
	self = (SudokuView*) g_object_new (object_type, NULL);
#line 67 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 67 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->game);
#line 67 "../src/sudoku-view.vala"
	self->priv->game = _tmp0_;
#line 69 "../src/sudoku-view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
#line 70 "../src/sudoku-view.vala"
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
#line 71 "../src/sudoku-view.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
#line 73 "../src/sudoku-view.vala"
	_tmp1_ = sudoku_game_get_mode (game);
#line 73 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_;
#line 73 "../src/sudoku-view.vala"
	if (_tmp2_ == GAME_MODE_CREATE) {
#line 74 "../src/sudoku-view.vala"
		self->priv->_show_warnings = TRUE;
#line 697 "sudoku-view.c"
	} else {
#line 76 "../src/sudoku-view.vala"
		self->priv->_show_warnings = g_settings_get_boolean (settings, "show-warnings");
#line 701 "sudoku-view.c"
	}
#line 77 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = g_settings_get_boolean (settings, "show-possibilities");
#line 78 "../src/sudoku-view.vala"
	self->priv->_simple_warnings = g_settings_get_boolean (settings, "simple-warnings");
#line 79 "../src/sudoku-view.vala"
	self->priv->_show_earmark_warnings = g_settings_get_boolean (settings, "show-earmark-warnings");
#line 80 "../src/sudoku-view.vala"
	self->priv->_highlighter = g_settings_get_boolean (settings, "highlighter");
#line 81 "../src/sudoku-view.vala"
	self->number_picker_second_click = g_settings_get_boolean (settings, "number-picker-second-click");
#line 82 "../src/sudoku-view.vala"
	self->autoclean_earmarks = g_settings_get_boolean (settings, "autoclean-earmarks");
#line 83 "../src/sudoku-view.vala"
	self->highlight_row_column = g_settings_get_boolean (settings, "highlight-row-column");
#line 84 "../src/sudoku-view.vala"
	self->highlight_block = g_settings_get_boolean (settings, "highlight-block");
#line 85 "../src/sudoku-view.vala"
	self->highlight_numbers = g_settings_get_boolean (settings, "highlight-numbers");
#line 87 "../src/sudoku-view.vala"
	_tmp3_ = (GtkOverlay*) gtk_overlay_new ();
#line 87 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp3_);
#line 87 "../src/sudoku-view.vala"
	overlay = _tmp3_;
#line 88 "../src/sudoku-view.vala"
	_tmp4_ = overlay;
#line 88 "../src/sudoku-view.vala"
	_tmp5_ = sudoku_frame_new ((GtkWidget*) _tmp4_);
#line 88 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp5_);
#line 88 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->frame);
#line 88 "../src/sudoku-view.vala"
	self->priv->frame = _tmp5_;
#line 89 "../src/sudoku-view.vala"
	_tmp6_ = self->priv->frame;
#line 89 "../src/sudoku-view.vala"
	adw_bin_set_child ((AdwBin*) self, (GtkWidget*) _tmp6_);
#line 91 "../src/sudoku-view.vala"
	_tmp7_ = (GtkLabel*) gtk_label_new ("Paused");
#line 91 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp7_);
#line 91 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->paused_label);
#line 91 "../src/sudoku-view.vala"
	self->priv->paused_label = _tmp7_;
#line 92 "../src/sudoku-view.vala"
	_tmp8_ = self->priv->paused_label;
#line 92 "../src/sudoku-view.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp8_, "paused");
#line 93 "../src/sudoku-view.vala"
	_tmp9_ = self->priv->paused_label;
#line 93 "../src/sudoku-view.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp9_, FALSE);
#line 94 "../src/sudoku-view.vala"
	_tmp10_ = overlay;
#line 94 "../src/sudoku-view.vala"
	_tmp11_ = self->priv->paused_label;
#line 94 "../src/sudoku-view.vala"
	gtk_overlay_add_overlay (_tmp10_, (GtkWidget*) _tmp11_);
#line 96 "../src/sudoku-view.vala"
	_tmp12_ = self->priv->game;
#line 96 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp12_, "paused-changed", (GCallback) ___lambda8__sudoku_game_paused_changed, self, 0);
#line 123 "../src/sudoku-view.vala"
	_tmp13_ = (GtkGrid*) gtk_grid_new ();
#line 123 "../src/sudoku-view.vala"
	gtk_grid_set_row_spacing (_tmp13_, 2);
#line 123 "../src/sudoku-view.vala"
	gtk_grid_set_column_spacing (_tmp13_, 2);
#line 123 "../src/sudoku-view.vala"
	gtk_grid_set_column_homogeneous (_tmp13_, TRUE);
#line 123 "../src/sudoku-view.vala"
	gtk_grid_set_row_homogeneous (_tmp13_, TRUE);
#line 123 "../src/sudoku-view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp13_, TRUE);
#line 123 "../src/sudoku-view.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp13_, TRUE);
#line 123 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp13_);
#line 123 "../src/sudoku-view.vala"
	grid = _tmp13_;
#line 131 "../src/sudoku-view.vala"
	_tmp14_ = grid;
#line 131 "../src/sudoku-view.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp14_, "board");
#line 132 "../src/sudoku-view.vala"
	_tmp15_ = overlay;
#line 132 "../src/sudoku-view.vala"
	_tmp16_ = grid;
#line 132 "../src/sudoku-view.vala"
	gtk_overlay_set_child (_tmp15_, (GtkWidget*) _tmp16_);
#line 134 "../src/sudoku-view.vala"
	_tmp17_ = sudoku_game_get_board (game);
#line 134 "../src/sudoku-view.vala"
	_tmp18_ = _tmp17_;
#line 134 "../src/sudoku-view.vala"
	_tmp19_ = sudoku_board_get_block_rows (_tmp18_);
#line 134 "../src/sudoku-view.vala"
	_tmp20_ = _tmp19_;
#line 134 "../src/sudoku-view.vala"
	_tmp21_ = sudoku_game_get_board (game);
#line 134 "../src/sudoku-view.vala"
	_tmp22_ = _tmp21_;
#line 134 "../src/sudoku-view.vala"
	_tmp23_ = sudoku_board_get_block_cols (_tmp22_);
#line 134 "../src/sudoku-view.vala"
	_tmp24_ = _tmp23_;
#line 134 "../src/sudoku-view.vala"
	_tmp25_ = g_new0 (GtkGrid*, (_tmp20_ * _tmp24_) + 1);
#line 134 "../src/sudoku-view.vala"
	blocks = _tmp25_;
#line 134 "../src/sudoku-view.vala"
	blocks_length1 = _tmp20_;
#line 134 "../src/sudoku-view.vala"
	blocks_length2 = _tmp24_;
#line 819 "sudoku-view.c"
	{
		gint block_row = 0;
#line 135 "../src/sudoku-view.vala"
		block_row = 0;
#line 824 "sudoku-view.c"
		{
			gboolean _tmp26_ = FALSE;
#line 135 "../src/sudoku-view.vala"
			_tmp26_ = TRUE;
#line 135 "../src/sudoku-view.vala"
			while (TRUE) {
#line 831 "sudoku-view.c"
				SudokuBoard* _tmp28_;
				SudokuBoard* _tmp29_;
				gint _tmp30_;
				gint _tmp31_;
#line 135 "../src/sudoku-view.vala"
				if (!_tmp26_) {
#line 838 "sudoku-view.c"
					gint _tmp27_;
#line 135 "../src/sudoku-view.vala"
					_tmp27_ = block_row;
#line 135 "../src/sudoku-view.vala"
					block_row = _tmp27_ + 1;
#line 844 "sudoku-view.c"
				}
#line 135 "../src/sudoku-view.vala"
				_tmp26_ = FALSE;
#line 135 "../src/sudoku-view.vala"
				_tmp28_ = sudoku_game_get_board (game);
#line 135 "../src/sudoku-view.vala"
				_tmp29_ = _tmp28_;
#line 135 "../src/sudoku-view.vala"
				_tmp30_ = sudoku_board_get_block_rows (_tmp29_);
#line 135 "../src/sudoku-view.vala"
				_tmp31_ = _tmp30_;
#line 135 "../src/sudoku-view.vala"
				if (!(block_row < _tmp31_)) {
#line 135 "../src/sudoku-view.vala"
					break;
#line 860 "sudoku-view.c"
				}
				{
					gint block_col = 0;
#line 137 "../src/sudoku-view.vala"
					block_col = 0;
#line 866 "sudoku-view.c"
					{
						gboolean _tmp32_ = FALSE;
#line 137 "../src/sudoku-view.vala"
						_tmp32_ = TRUE;
#line 137 "../src/sudoku-view.vala"
						while (TRUE) {
#line 873 "sudoku-view.c"
							SudokuBoard* _tmp34_;
							SudokuBoard* _tmp35_;
							gint _tmp36_;
							gint _tmp37_;
							GtkGrid* block_grid = NULL;
							GtkGrid* _tmp38_;
							GtkGrid* _tmp39_;
							GtkGrid* _tmp40_;
							GtkGrid* _tmp41_;
							GtkGrid* _tmp42_;
							GtkGrid* _tmp43_;
							GtkGrid* _tmp44_;
							GtkGrid* _tmp45_;
							GtkGrid** _tmp46_;
							gint _tmp46__length1;
							gint _tmp46__length2;
							GtkGrid* _tmp47_;
							GtkGrid* _tmp48_;
#line 137 "../src/sudoku-view.vala"
							if (!_tmp32_) {
#line 894 "sudoku-view.c"
								gint _tmp33_;
#line 137 "../src/sudoku-view.vala"
								_tmp33_ = block_col;
#line 137 "../src/sudoku-view.vala"
								block_col = _tmp33_ + 1;
#line 900 "sudoku-view.c"
							}
#line 137 "../src/sudoku-view.vala"
							_tmp32_ = FALSE;
#line 137 "../src/sudoku-view.vala"
							_tmp34_ = sudoku_game_get_board (game);
#line 137 "../src/sudoku-view.vala"
							_tmp35_ = _tmp34_;
#line 137 "../src/sudoku-view.vala"
							_tmp36_ = sudoku_board_get_block_cols (_tmp35_);
#line 137 "../src/sudoku-view.vala"
							_tmp37_ = _tmp36_;
#line 137 "../src/sudoku-view.vala"
							if (!(block_col < _tmp37_)) {
#line 137 "../src/sudoku-view.vala"
								break;
#line 916 "sudoku-view.c"
							}
#line 139 "../src/sudoku-view.vala"
							_tmp38_ = (GtkGrid*) gtk_grid_new ();
#line 139 "../src/sudoku-view.vala"
							g_object_ref_sink (_tmp38_);
#line 139 "../src/sudoku-view.vala"
							block_grid = _tmp38_;
#line 140 "../src/sudoku-view.vala"
							_tmp39_ = block_grid;
#line 140 "../src/sudoku-view.vala"
							gtk_grid_set_row_spacing (_tmp39_, 1);
#line 141 "../src/sudoku-view.vala"
							_tmp40_ = block_grid;
#line 141 "../src/sudoku-view.vala"
							gtk_grid_set_column_spacing (_tmp40_, 1);
#line 142 "../src/sudoku-view.vala"
							_tmp41_ = block_grid;
#line 142 "../src/sudoku-view.vala"
							gtk_grid_set_column_homogeneous (_tmp41_, TRUE);
#line 143 "../src/sudoku-view.vala"
							_tmp42_ = block_grid;
#line 143 "../src/sudoku-view.vala"
							gtk_grid_set_row_homogeneous (_tmp42_, TRUE);
#line 144 "../src/sudoku-view.vala"
							_tmp43_ = block_grid;
#line 144 "../src/sudoku-view.vala"
							gtk_widget_add_css_class ((GtkWidget*) _tmp43_, "block");
#line 145 "../src/sudoku-view.vala"
							_tmp44_ = grid;
#line 145 "../src/sudoku-view.vala"
							_tmp45_ = block_grid;
#line 145 "../src/sudoku-view.vala"
							gtk_grid_attach (_tmp44_, (GtkWidget*) _tmp45_, block_col, block_row, 1, 1);
#line 147 "../src/sudoku-view.vala"
							_tmp46_ = blocks;
#line 147 "../src/sudoku-view.vala"
							_tmp46__length1 = blocks_length1;
#line 147 "../src/sudoku-view.vala"
							_tmp46__length2 = blocks_length2;
#line 147 "../src/sudoku-view.vala"
							_tmp47_ = block_grid;
#line 147 "../src/sudoku-view.vala"
							_tmp48_ = _g_object_ref0 (_tmp47_);
#line 147 "../src/sudoku-view.vala"
							_g_object_unref0 (_tmp46_[(block_row * _tmp46__length2) + block_col]);
#line 147 "../src/sudoku-view.vala"
							_tmp46_[(block_row * _tmp46__length2) + block_col] = _tmp48_;
#line 137 "../src/sudoku-view.vala"
							_g_object_unref0 (block_grid);
#line 966 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 151 "../src/sudoku-view.vala"
	_tmp49_ = sudoku_game_get_board (game);
#line 151 "../src/sudoku-view.vala"
	_tmp50_ = _tmp49_;
#line 151 "../src/sudoku-view.vala"
	_tmp51_ = sudoku_board_get_rows (_tmp50_);
#line 151 "../src/sudoku-view.vala"
	_tmp52_ = _tmp51_;
#line 151 "../src/sudoku-view.vala"
	_tmp53_ = sudoku_game_get_board (game);
#line 151 "../src/sudoku-view.vala"
	_tmp54_ = _tmp53_;
#line 151 "../src/sudoku-view.vala"
	_tmp55_ = sudoku_board_get_cols (_tmp54_);
#line 151 "../src/sudoku-view.vala"
	_tmp56_ = _tmp55_;
#line 151 "../src/sudoku-view.vala"
	_tmp57_ = g_new0 (SudokuCell*, (_tmp52_ * _tmp56_) + 1);
#line 151 "../src/sudoku-view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 151 "../src/sudoku-view.vala"
	self->priv->cells = _tmp57_;
#line 151 "../src/sudoku-view.vala"
	self->priv->cells_length1 = _tmp52_;
#line 151 "../src/sudoku-view.vala"
	self->priv->cells_length2 = _tmp56_;
#line 999 "sudoku-view.c"
	{
		gint row = 0;
#line 152 "../src/sudoku-view.vala"
		row = 0;
#line 1004 "sudoku-view.c"
		{
			gboolean _tmp58_ = FALSE;
#line 152 "../src/sudoku-view.vala"
			_tmp58_ = TRUE;
#line 152 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1011 "sudoku-view.c"
				SudokuBoard* _tmp60_;
				SudokuBoard* _tmp61_;
				gint _tmp62_;
				gint _tmp63_;
#line 152 "../src/sudoku-view.vala"
				if (!_tmp58_) {
#line 1018 "sudoku-view.c"
					gint _tmp59_;
#line 152 "../src/sudoku-view.vala"
					_tmp59_ = row;
#line 152 "../src/sudoku-view.vala"
					row = _tmp59_ + 1;
#line 1024 "sudoku-view.c"
				}
#line 152 "../src/sudoku-view.vala"
				_tmp58_ = FALSE;
#line 152 "../src/sudoku-view.vala"
				_tmp60_ = sudoku_game_get_board (game);
#line 152 "../src/sudoku-view.vala"
				_tmp61_ = _tmp60_;
#line 152 "../src/sudoku-view.vala"
				_tmp62_ = sudoku_board_get_rows (_tmp61_);
#line 152 "../src/sudoku-view.vala"
				_tmp63_ = _tmp62_;
#line 152 "../src/sudoku-view.vala"
				if (!(row < _tmp63_)) {
#line 152 "../src/sudoku-view.vala"
					break;
#line 1040 "sudoku-view.c"
				}
				{
					gint col = 0;
#line 154 "../src/sudoku-view.vala"
					col = 0;
#line 1046 "sudoku-view.c"
					{
						gboolean _tmp64_ = FALSE;
#line 154 "../src/sudoku-view.vala"
						_tmp64_ = TRUE;
#line 154 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1053 "sudoku-view.c"
							SudokuBoard* _tmp66_;
							SudokuBoard* _tmp67_;
							gint _tmp68_;
							gint _tmp69_;
							SudokuCell* cell = NULL;
							SudokuCell* _tmp70_;
							SudokuCell* _tmp71_;
							GtkGrid** _tmp72_;
							gint _tmp72__length1;
							gint _tmp72__length2;
							SudokuBoard* _tmp73_;
							SudokuBoard* _tmp74_;
							gint _tmp75_;
							gint _tmp76_;
							SudokuBoard* _tmp77_;
							SudokuBoard* _tmp78_;
							gint _tmp79_;
							gint _tmp80_;
							GtkGrid* _tmp81_;
							SudokuCell* _tmp82_;
							SudokuBoard* _tmp83_;
							SudokuBoard* _tmp84_;
							gint _tmp85_;
							gint _tmp86_;
							SudokuBoard* _tmp87_;
							SudokuBoard* _tmp88_;
							gint _tmp89_;
							gint _tmp90_;
							SudokuCell** _tmp91_;
							gint _tmp91__length1;
							gint _tmp91__length2;
							SudokuCell* _tmp92_;
							SudokuCell* _tmp93_;
#line 154 "../src/sudoku-view.vala"
							if (!_tmp64_) {
#line 1089 "sudoku-view.c"
								gint _tmp65_;
#line 154 "../src/sudoku-view.vala"
								_tmp65_ = col;
#line 154 "../src/sudoku-view.vala"
								col = _tmp65_ + 1;
#line 1095 "sudoku-view.c"
							}
#line 154 "../src/sudoku-view.vala"
							_tmp64_ = FALSE;
#line 154 "../src/sudoku-view.vala"
							_tmp66_ = sudoku_game_get_board (game);
#line 154 "../src/sudoku-view.vala"
							_tmp67_ = _tmp66_;
#line 154 "../src/sudoku-view.vala"
							_tmp68_ = sudoku_board_get_cols (_tmp67_);
#line 154 "../src/sudoku-view.vala"
							_tmp69_ = _tmp68_;
#line 154 "../src/sudoku-view.vala"
							if (!(col < _tmp69_)) {
#line 154 "../src/sudoku-view.vala"
								break;
#line 1111 "sudoku-view.c"
							}
#line 156 "../src/sudoku-view.vala"
							_tmp70_ = sudoku_cell_new (row, col, game, self);
#line 156 "../src/sudoku-view.vala"
							g_object_ref_sink (_tmp70_);
#line 156 "../src/sudoku-view.vala"
							cell = _tmp70_;
#line 157 "../src/sudoku-view.vala"
							_tmp71_ = cell;
#line 157 "../src/sudoku-view.vala"
							sudoku_cell_get_visible_earmarks (_tmp71_);
#line 158 "../src/sudoku-view.vala"
							_tmp72_ = blocks;
#line 158 "../src/sudoku-view.vala"
							_tmp72__length1 = blocks_length1;
#line 158 "../src/sudoku-view.vala"
							_tmp72__length2 = blocks_length2;
#line 158 "../src/sudoku-view.vala"
							_tmp73_ = sudoku_game_get_board (game);
#line 158 "../src/sudoku-view.vala"
							_tmp74_ = _tmp73_;
#line 158 "../src/sudoku-view.vala"
							_tmp75_ = sudoku_board_get_block_rows (_tmp74_);
#line 158 "../src/sudoku-view.vala"
							_tmp76_ = _tmp75_;
#line 158 "../src/sudoku-view.vala"
							_tmp77_ = sudoku_game_get_board (game);
#line 158 "../src/sudoku-view.vala"
							_tmp78_ = _tmp77_;
#line 158 "../src/sudoku-view.vala"
							_tmp79_ = sudoku_board_get_block_cols (_tmp78_);
#line 158 "../src/sudoku-view.vala"
							_tmp80_ = _tmp79_;
#line 158 "../src/sudoku-view.vala"
							_tmp81_ = _tmp72_[((row / _tmp76_) * _tmp72__length2) + (col / _tmp80_)];
#line 158 "../src/sudoku-view.vala"
							_tmp82_ = cell;
#line 158 "../src/sudoku-view.vala"
							_tmp83_ = sudoku_game_get_board (game);
#line 158 "../src/sudoku-view.vala"
							_tmp84_ = _tmp83_;
#line 158 "../src/sudoku-view.vala"
							_tmp85_ = sudoku_board_get_block_cols (_tmp84_);
#line 158 "../src/sudoku-view.vala"
							_tmp86_ = _tmp85_;
#line 158 "../src/sudoku-view.vala"
							_tmp87_ = sudoku_game_get_board (game);
#line 158 "../src/sudoku-view.vala"
							_tmp88_ = _tmp87_;
#line 158 "../src/sudoku-view.vala"
							_tmp89_ = sudoku_board_get_block_rows (_tmp88_);
#line 158 "../src/sudoku-view.vala"
							_tmp90_ = _tmp89_;
#line 158 "../src/sudoku-view.vala"
							gtk_grid_attach (_tmp81_, (GtkWidget*) _tmp82_, col % _tmp86_, row % _tmp90_, 1, 1);
#line 159 "../src/sudoku-view.vala"
							_tmp91_ = self->priv->cells;
#line 159 "../src/sudoku-view.vala"
							_tmp91__length1 = self->priv->cells_length1;
#line 159 "../src/sudoku-view.vala"
							_tmp91__length2 = self->priv->cells_length2;
#line 159 "../src/sudoku-view.vala"
							_tmp92_ = cell;
#line 159 "../src/sudoku-view.vala"
							_tmp93_ = _g_object_ref0 (_tmp92_);
#line 159 "../src/sudoku-view.vala"
							_g_object_unref0 (_tmp91_[(row * _tmp91__length2) + col]);
#line 159 "../src/sudoku-view.vala"
							_tmp91_[(row * _tmp91__length2) + col] = _tmp93_;
#line 154 "../src/sudoku-view.vala"
							_g_object_unref0 (cell);
#line 1183 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 163 "../src/sudoku-view.vala"
	_tmp94_ = self->priv->game;
#line 163 "../src/sudoku-view.vala"
	_tmp95_ = sudoku_game_get_board (_tmp94_);
#line 163 "../src/sudoku-view.vala"
	_tmp96_ = _tmp95_;
#line 163 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp96_, "cell-changed", (GCallback) _sudoku_view_cell_changed_cb_sudoku_board_cell_changed, self, 0);
#line 164 "../src/sudoku-view.vala"
	_tmp97_ = self->priv->game;
#line 164 "../src/sudoku-view.vala"
	_tmp98_ = sudoku_game_get_board (_tmp97_);
#line 164 "../src/sudoku-view.vala"
	_tmp99_ = _tmp98_;
#line 164 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp99_, "earmark-changed", (GCallback) _sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed, self, 0);
#line 165 "../src/sudoku-view.vala"
	g_signal_connect_object (self, "selection-changed", (GCallback) _sudoku_view_selection_changed_cb_sudoku_view_selection_changed, self, 0);
#line 167 "../src/sudoku-view.vala"
	_tmp102_ = sudoku_view_get_show_possibilities (self);
#line 167 "../src/sudoku-view.vala"
	_tmp103_ = _tmp102_;
#line 167 "../src/sudoku-view.vala"
	if (_tmp103_) {
#line 1214 "sudoku-view.c"
		GameMode _tmp104_;
		GameMode _tmp105_;
#line 167 "../src/sudoku-view.vala"
		_tmp104_ = sudoku_game_get_mode (game);
#line 167 "../src/sudoku-view.vala"
		_tmp105_ = _tmp104_;
#line 167 "../src/sudoku-view.vala"
		_tmp101_ = _tmp105_ != GAME_MODE_CREATE;
#line 1223 "sudoku-view.c"
	} else {
#line 167 "../src/sudoku-view.vala"
		_tmp101_ = FALSE;
#line 1227 "sudoku-view.c"
	}
#line 167 "../src/sudoku-view.vala"
	if (_tmp101_) {
#line 1231 "sudoku-view.c"
		SudokuBoard* _tmp106_;
		SudokuBoard* _tmp107_;
		gdouble _tmp108_;
		gdouble _tmp109_;
#line 167 "../src/sudoku-view.vala"
		_tmp106_ = sudoku_game_get_board (game);
#line 167 "../src/sudoku-view.vala"
		_tmp107_ = _tmp106_;
#line 167 "../src/sudoku-view.vala"
		_tmp108_ = sudoku_board_get_previous_played_time (_tmp107_);
#line 167 "../src/sudoku-view.vala"
		_tmp109_ = _tmp108_;
#line 167 "../src/sudoku-view.vala"
		_tmp100_ = _tmp109_ == 0.0;
#line 1246 "sudoku-view.c"
	} else {
#line 167 "../src/sudoku-view.vala"
		_tmp100_ = FALSE;
#line 1250 "sudoku-view.c"
	}
#line 167 "../src/sudoku-view.vala"
	if (_tmp100_) {
#line 168 "../src/sudoku-view.vala"
		sudoku_game_enable_all_earmark_possibilities (game);
#line 1256 "sudoku-view.c"
	}
#line 170 "../src/sudoku-view.vala"
	sudoku_view_update_warnings (self);
#line 65 "../src/sudoku-view.vala"
	blocks = (_vala_array_free (blocks, blocks_length1 * blocks_length2, (GDestroyNotify) g_object_unref), NULL);
#line 65 "../src/sudoku-view.vala"
	_g_object_unref0 (grid);
#line 65 "../src/sudoku-view.vala"
	_g_object_unref0 (overlay);
#line 65 "../src/sudoku-view.vala"
	return self;
#line 1268 "sudoku-view.c"
}

SudokuView*
sudoku_view_new (SudokuGame* game,
                 GSettings* settings)
{
#line 65 "../src/sudoku-view.vala"
	return sudoku_view_construct (TYPE_SUDOKU_VIEW, game, settings);
#line 1277 "sudoku-view.c"
}

static void
sudoku_view_selection_changed_cb (SudokuView* self,
                                  gint old_row,
                                  gint old_col,
                                  gint new_row,
                                  gint new_col)
{
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	SudokuCell* _tmp1_;
#line 241 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 243 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, old_row, old_col, FALSE);
#line 244 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, new_row, new_col, TRUE);
#line 245 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->cells;
#line 245 "../src/sudoku-view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 245 "../src/sudoku-view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 245 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_[(old_row * _tmp0__length2) + old_col];
#line 245 "../src/sudoku-view.vala"
	sudoku_cell_dismiss_popover (_tmp1_);
#line 1307 "sudoku-view.c"
}

static void
sudoku_view_cell_changed_cb (SudokuView* self,
                             gint row,
                             gint col,
                             gint old_val,
                             gint new_val)
{
	StackAction action = 0;
	SudokuGame* _tmp0_;
	SudokuCell** _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	SudokuCell* _tmp4_;
#line 248 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 250 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->game;
#line 250 "../src/sudoku-view.vala"
	action = sudoku_game_get_current_stack_action (_tmp0_);
#line 251 "../src/sudoku-view.vala"
	if (!stack_action_is_multi_value_step (action)) {
#line 1331 "sudoku-view.c"
		SudokuCell** _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		SudokuCell* _tmp2_;
#line 252 "../src/sudoku-view.vala"
		_tmp1_ = self->priv->cells;
#line 252 "../src/sudoku-view.vala"
		_tmp1__length1 = self->priv->cells_length1;
#line 252 "../src/sudoku-view.vala"
		_tmp1__length2 = self->priv->cells_length2;
#line 252 "../src/sudoku-view.vala"
		_tmp2_ = _tmp1_[(row * _tmp1__length2) + col];
#line 252 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp2_);
#line 1346 "sudoku-view.c"
	}
#line 254 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->cells;
#line 254 "../src/sudoku-view.vala"
	_tmp3__length1 = self->priv->cells_length1;
#line 254 "../src/sudoku-view.vala"
	_tmp3__length2 = self->priv->cells_length2;
#line 254 "../src/sudoku-view.vala"
	_tmp4_ = _tmp3_[(row * _tmp3__length2) + col];
#line 254 "../src/sudoku-view.vala"
	sudoku_cell_update_value (_tmp4_);
#line 255 "../src/sudoku-view.vala"
	sudoku_view_update_warnings (self);
#line 256 "../src/sudoku-view.vala"
	sudoku_view_set_value_highlighter (self, old_val, FALSE);
#line 257 "../src/sudoku-view.vala"
	sudoku_view_set_value_highlighter (self, new_val, TRUE);
#line 1364 "sudoku-view.c"
}

static void
sudoku_view_earmark_changed_cb (SudokuView* self,
                                gint row,
                                gint col,
                                gint num,
                                gboolean enabled)
{
	StackAction action = 0;
	SudokuGame* _tmp0_;
	SudokuCell** _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	SudokuCell* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_;
	gboolean _tmp7_;
#line 260 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 262 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->game;
#line 262 "../src/sudoku-view.vala"
	action = sudoku_game_get_current_stack_action (_tmp0_);
#line 263 "../src/sudoku-view.vala"
	if (!stack_action_is_multi_step (action)) {
#line 1391 "sudoku-view.c"
		SudokuCell** _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		SudokuCell* _tmp2_;
#line 264 "../src/sudoku-view.vala"
		_tmp1_ = self->priv->cells;
#line 264 "../src/sudoku-view.vala"
		_tmp1__length1 = self->priv->cells_length1;
#line 264 "../src/sudoku-view.vala"
		_tmp1__length2 = self->priv->cells_length2;
#line 264 "../src/sudoku-view.vala"
		_tmp2_ = _tmp1_[(row * _tmp1__length2) + col];
#line 264 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp2_);
#line 1406 "sudoku-view.c"
	}
#line 266 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->cells;
#line 266 "../src/sudoku-view.vala"
	_tmp3__length1 = self->priv->cells_length1;
#line 266 "../src/sudoku-view.vala"
	_tmp3__length2 = self->priv->cells_length2;
#line 266 "../src/sudoku-view.vala"
	_tmp4_ = _tmp3_[(row * _tmp3__length2) + col];
#line 266 "../src/sudoku-view.vala"
	sudoku_cell_get_visible_earmark (_tmp4_, num);
#line 267 "../src/sudoku-view.vala"
	_tmp6_ = sudoku_view_get_show_warnings (self);
#line 267 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_;
#line 267 "../src/sudoku-view.vala"
	if (_tmp7_) {
#line 267 "../src/sudoku-view.vala"
		_tmp5_ = enabled;
#line 1426 "sudoku-view.c"
	} else {
#line 267 "../src/sudoku-view.vala"
		_tmp5_ = FALSE;
#line 1430 "sudoku-view.c"
	}
#line 267 "../src/sudoku-view.vala"
	if (_tmp5_) {
#line 1434 "sudoku-view.c"
		SudokuCell** _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
		SudokuCell* _tmp9_;
#line 268 "../src/sudoku-view.vala"
		_tmp8_ = self->priv->cells;
#line 268 "../src/sudoku-view.vala"
		_tmp8__length1 = self->priv->cells_length1;
#line 268 "../src/sudoku-view.vala"
		_tmp8__length2 = self->priv->cells_length2;
#line 268 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_[(row * _tmp8__length2) + col];
#line 268 "../src/sudoku-view.vala"
		sudoku_cell_check_earmark_warnings (_tmp9_, num);
#line 1449 "sudoku-view.c"
	}
}

static void
sudoku_view_set_cell_highlighter (SudokuView* self,
                                  gint row,
                                  gint col,
                                  gboolean enabled)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	SudokuCell* cell = NULL;
	SudokuCell** _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	SudokuCell* _tmp3_;
	SudokuCell* _tmp4_;
#line 271 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 273 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_view_get_highlighter (self);
#line 273 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 273 "../src/sudoku-view.vala"
	if (!_tmp1_) {
#line 274 "../src/sudoku-view.vala"
		return;
#line 1477 "sudoku-view.c"
	}
#line 276 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->cells;
#line 276 "../src/sudoku-view.vala"
	_tmp2__length1 = self->priv->cells_length1;
#line 276 "../src/sudoku-view.vala"
	_tmp2__length2 = self->priv->cells_length2;
#line 276 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_[(row * _tmp2__length2) + col];
#line 276 "../src/sudoku-view.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 276 "../src/sudoku-view.vala"
	cell = _tmp4_;
#line 1491 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 278 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 1496 "sudoku-view.c"
		{
			gboolean _tmp5_ = FALSE;
#line 278 "../src/sudoku-view.vala"
			_tmp5_ = TRUE;
#line 278 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1503 "sudoku-view.c"
				SudokuGame* _tmp7_;
				SudokuBoard* _tmp8_;
				SudokuBoard* _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
#line 278 "../src/sudoku-view.vala"
				if (!_tmp5_) {
#line 1511 "sudoku-view.c"
					gint _tmp6_;
#line 278 "../src/sudoku-view.vala"
					_tmp6_ = col_tmp;
#line 278 "../src/sudoku-view.vala"
					col_tmp = _tmp6_ + 1;
#line 1517 "sudoku-view.c"
				}
#line 278 "../src/sudoku-view.vala"
				_tmp5_ = FALSE;
#line 278 "../src/sudoku-view.vala"
				_tmp7_ = self->priv->game;
#line 278 "../src/sudoku-view.vala"
				_tmp8_ = sudoku_game_get_board (_tmp7_);
#line 278 "../src/sudoku-view.vala"
				_tmp9_ = _tmp8_;
#line 278 "../src/sudoku-view.vala"
				_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 278 "../src/sudoku-view.vala"
				_tmp11_ = _tmp10_;
#line 278 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp11_)) {
#line 278 "../src/sudoku-view.vala"
					break;
#line 1535 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 280 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 1541 "sudoku-view.c"
					{
						gboolean _tmp12_ = FALSE;
#line 280 "../src/sudoku-view.vala"
						_tmp12_ = TRUE;
#line 280 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1548 "sudoku-view.c"
							SudokuGame* _tmp14_;
							SudokuBoard* _tmp15_;
							SudokuBoard* _tmp16_;
							gint _tmp17_;
							gint _tmp18_;
							SudokuCell* cell_tmp = NULL;
							SudokuCell** _tmp19_;
							gint _tmp19__length1;
							gint _tmp19__length2;
							SudokuCell* _tmp20_;
							SudokuCell* _tmp21_;
							SudokuCell* _tmp22_;
							SudokuCell* _tmp23_;
							gboolean _tmp24_ = FALSE;
							SudokuCell* _tmp25_;
							gint _tmp26_;
							gint _tmp27_;
							gboolean _tmp42_ = FALSE;
							SudokuCell* _tmp43_;
							gboolean _tmp44_;
							gboolean _tmp45_;
#line 280 "../src/sudoku-view.vala"
							if (!_tmp12_) {
#line 1572 "sudoku-view.c"
								gint _tmp13_;
#line 280 "../src/sudoku-view.vala"
								_tmp13_ = row_tmp;
#line 280 "../src/sudoku-view.vala"
								row_tmp = _tmp13_ + 1;
#line 1578 "sudoku-view.c"
							}
#line 280 "../src/sudoku-view.vala"
							_tmp12_ = FALSE;
#line 280 "../src/sudoku-view.vala"
							_tmp14_ = self->priv->game;
#line 280 "../src/sudoku-view.vala"
							_tmp15_ = sudoku_game_get_board (_tmp14_);
#line 280 "../src/sudoku-view.vala"
							_tmp16_ = _tmp15_;
#line 280 "../src/sudoku-view.vala"
							_tmp17_ = sudoku_board_get_rows (_tmp16_);
#line 280 "../src/sudoku-view.vala"
							_tmp18_ = _tmp17_;
#line 280 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp18_)) {
#line 280 "../src/sudoku-view.vala"
								break;
#line 1596 "sudoku-view.c"
							}
#line 282 "../src/sudoku-view.vala"
							_tmp19_ = self->priv->cells;
#line 282 "../src/sudoku-view.vala"
							_tmp19__length1 = self->priv->cells_length1;
#line 282 "../src/sudoku-view.vala"
							_tmp19__length2 = self->priv->cells_length2;
#line 282 "../src/sudoku-view.vala"
							_tmp20_ = _tmp19_[(row_tmp * _tmp19__length2) + col_tmp];
#line 282 "../src/sudoku-view.vala"
							_tmp21_ = _g_object_ref0 (_tmp20_);
#line 282 "../src/sudoku-view.vala"
							cell_tmp = _tmp21_;
#line 284 "../src/sudoku-view.vala"
							_tmp22_ = cell;
#line 284 "../src/sudoku-view.vala"
							_tmp23_ = cell_tmp;
#line 284 "../src/sudoku-view.vala"
							if (_tmp22_ == _tmp23_) {
#line 285 "../src/sudoku-view.vala"
								_g_object_unref0 (cell_tmp);
#line 285 "../src/sudoku-view.vala"
								continue;
#line 1620 "sudoku-view.c"
							}
#line 287 "../src/sudoku-view.vala"
							_tmp25_ = cell;
#line 287 "../src/sudoku-view.vala"
							_tmp26_ = sudoku_cell_get_value (_tmp25_);
#line 287 "../src/sudoku-view.vala"
							_tmp27_ = _tmp26_;
#line 287 "../src/sudoku-view.vala"
							if (_tmp27_ > 0) {
#line 287 "../src/sudoku-view.vala"
								_tmp24_ = self->highlight_numbers;
#line 1632 "sudoku-view.c"
							} else {
#line 287 "../src/sudoku-view.vala"
								_tmp24_ = FALSE;
#line 1636 "sudoku-view.c"
							}
#line 287 "../src/sudoku-view.vala"
							if (_tmp24_) {
#line 1640 "sudoku-view.c"
								SudokuCell* _tmp28_;
								gint _tmp29_;
								gint _tmp30_;
								SudokuCell* _tmp31_;
								gint _tmp32_;
								gint _tmp33_;
#line 289 "../src/sudoku-view.vala"
								_tmp28_ = cell;
#line 289 "../src/sudoku-view.vala"
								_tmp29_ = sudoku_cell_get_value (_tmp28_);
#line 289 "../src/sudoku-view.vala"
								_tmp30_ = _tmp29_;
#line 289 "../src/sudoku-view.vala"
								_tmp31_ = cell_tmp;
#line 289 "../src/sudoku-view.vala"
								_tmp32_ = sudoku_cell_get_value (_tmp31_);
#line 289 "../src/sudoku-view.vala"
								_tmp33_ = _tmp32_;
#line 289 "../src/sudoku-view.vala"
								if (_tmp30_ == _tmp33_) {
#line 1661 "sudoku-view.c"
									SudokuCell* _tmp34_;
#line 290 "../src/sudoku-view.vala"
									_tmp34_ = cell_tmp;
#line 290 "../src/sudoku-view.vala"
									sudoku_cell_set_highlighted_value (_tmp34_, enabled);
#line 1667 "sudoku-view.c"
								} else {
									SudokuCell* _tmp35_;
									gint _tmp36_;
									gint _tmp37_;
#line 291 "../src/sudoku-view.vala"
									_tmp35_ = cell_tmp;
#line 291 "../src/sudoku-view.vala"
									_tmp36_ = sudoku_cell_get_value (_tmp35_);
#line 291 "../src/sudoku-view.vala"
									_tmp37_ = _tmp36_;
#line 291 "../src/sudoku-view.vala"
									if (_tmp37_ == 0) {
#line 1680 "sudoku-view.c"
										SudokuCell* _tmp38_;
										SudokuCell* _tmp39_;
										gint _tmp40_;
										gint _tmp41_;
#line 292 "../src/sudoku-view.vala"
										_tmp38_ = cell_tmp;
#line 292 "../src/sudoku-view.vala"
										_tmp39_ = cell;
#line 292 "../src/sudoku-view.vala"
										_tmp40_ = sudoku_cell_get_value (_tmp39_);
#line 292 "../src/sudoku-view.vala"
										_tmp41_ = _tmp40_;
#line 292 "../src/sudoku-view.vala"
										sudoku_cell_set_earmark_highlight (_tmp38_, _tmp41_, enabled);
#line 1695 "sudoku-view.c"
									}
								}
							}
#line 295 "../src/sudoku-view.vala"
							_tmp43_ = cell_tmp;
#line 295 "../src/sudoku-view.vala"
							_tmp44_ = sudoku_cell_get_is_fixed (_tmp43_);
#line 295 "../src/sudoku-view.vala"
							_tmp45_ = _tmp44_;
#line 295 "../src/sudoku-view.vala"
							if (!_tmp45_) {
#line 1707 "sudoku-view.c"
								gboolean _tmp46_ = FALSE;
								gboolean _tmp47_ = FALSE;
#line 296 "../src/sudoku-view.vala"
								if (self->highlight_row_column) {
#line 1712 "sudoku-view.c"
									gboolean _tmp48_ = FALSE;
#line 296 "../src/sudoku-view.vala"
									if (row_tmp == row) {
#line 296 "../src/sudoku-view.vala"
										_tmp48_ = TRUE;
#line 1718 "sudoku-view.c"
									} else {
#line 296 "../src/sudoku-view.vala"
										_tmp48_ = col_tmp == col;
#line 1722 "sudoku-view.c"
									}
#line 296 "../src/sudoku-view.vala"
									_tmp47_ = _tmp48_;
#line 1726 "sudoku-view.c"
								} else {
#line 296 "../src/sudoku-view.vala"
									_tmp47_ = FALSE;
#line 1730 "sudoku-view.c"
								}
#line 296 "../src/sudoku-view.vala"
								if (_tmp47_) {
#line 296 "../src/sudoku-view.vala"
									_tmp46_ = TRUE;
#line 1736 "sudoku-view.c"
								} else {
									gboolean _tmp49_ = FALSE;
									gboolean _tmp50_ = FALSE;
#line 297 "../src/sudoku-view.vala"
									if (self->highlight_block) {
#line 1742 "sudoku-view.c"
										SudokuGame* _tmp51_;
										SudokuBoard* _tmp52_;
										SudokuBoard* _tmp53_;
										gint _tmp54_;
										gint _tmp55_;
										SudokuGame* _tmp56_;
										SudokuBoard* _tmp57_;
										SudokuBoard* _tmp58_;
										gint _tmp59_;
										gint _tmp60_;
#line 298 "../src/sudoku-view.vala"
										_tmp51_ = self->priv->game;
#line 298 "../src/sudoku-view.vala"
										_tmp52_ = sudoku_game_get_board (_tmp51_);
#line 298 "../src/sudoku-view.vala"
										_tmp53_ = _tmp52_;
#line 298 "../src/sudoku-view.vala"
										_tmp54_ = sudoku_board_get_block_cols (_tmp53_);
#line 298 "../src/sudoku-view.vala"
										_tmp55_ = _tmp54_;
#line 298 "../src/sudoku-view.vala"
										_tmp56_ = self->priv->game;
#line 298 "../src/sudoku-view.vala"
										_tmp57_ = sudoku_game_get_board (_tmp56_);
#line 298 "../src/sudoku-view.vala"
										_tmp58_ = _tmp57_;
#line 298 "../src/sudoku-view.vala"
										_tmp59_ = sudoku_board_get_block_cols (_tmp58_);
#line 298 "../src/sudoku-view.vala"
										_tmp60_ = _tmp59_;
#line 298 "../src/sudoku-view.vala"
										_tmp50_ = (row_tmp / _tmp55_) == (row / _tmp60_);
#line 1775 "sudoku-view.c"
									} else {
#line 297 "../src/sudoku-view.vala"
										_tmp50_ = FALSE;
#line 1779 "sudoku-view.c"
									}
#line 297 "../src/sudoku-view.vala"
									if (_tmp50_) {
#line 1783 "sudoku-view.c"
										SudokuGame* _tmp61_;
										SudokuBoard* _tmp62_;
										SudokuBoard* _tmp63_;
										gint _tmp64_;
										gint _tmp65_;
										SudokuGame* _tmp66_;
										SudokuBoard* _tmp67_;
										SudokuBoard* _tmp68_;
										gint _tmp69_;
										gint _tmp70_;
#line 299 "../src/sudoku-view.vala"
										_tmp61_ = self->priv->game;
#line 299 "../src/sudoku-view.vala"
										_tmp62_ = sudoku_game_get_board (_tmp61_);
#line 299 "../src/sudoku-view.vala"
										_tmp63_ = _tmp62_;
#line 299 "../src/sudoku-view.vala"
										_tmp64_ = sudoku_board_get_block_rows (_tmp63_);
#line 299 "../src/sudoku-view.vala"
										_tmp65_ = _tmp64_;
#line 299 "../src/sudoku-view.vala"
										_tmp66_ = self->priv->game;
#line 299 "../src/sudoku-view.vala"
										_tmp67_ = sudoku_game_get_board (_tmp66_);
#line 299 "../src/sudoku-view.vala"
										_tmp68_ = _tmp67_;
#line 299 "../src/sudoku-view.vala"
										_tmp69_ = sudoku_board_get_block_rows (_tmp68_);
#line 299 "../src/sudoku-view.vala"
										_tmp70_ = _tmp69_;
#line 299 "../src/sudoku-view.vala"
										_tmp49_ = (col_tmp / _tmp65_) == (col / _tmp70_);
#line 1816 "sudoku-view.c"
									} else {
#line 297 "../src/sudoku-view.vala"
										_tmp49_ = FALSE;
#line 1820 "sudoku-view.c"
									}
#line 297 "../src/sudoku-view.vala"
									_tmp46_ = _tmp49_;
#line 1824 "sudoku-view.c"
								}
#line 296 "../src/sudoku-view.vala"
								_tmp42_ = _tmp46_;
#line 1828 "sudoku-view.c"
							} else {
#line 295 "../src/sudoku-view.vala"
								_tmp42_ = FALSE;
#line 1832 "sudoku-view.c"
							}
#line 295 "../src/sudoku-view.vala"
							if (_tmp42_) {
#line 1836 "sudoku-view.c"
								SudokuCell* _tmp71_;
#line 301 "../src/sudoku-view.vala"
								_tmp71_ = cell_tmp;
#line 301 "../src/sudoku-view.vala"
								sudoku_cell_set_highlighted_background (_tmp71_, enabled);
#line 1842 "sudoku-view.c"
							}
#line 280 "../src/sudoku-view.vala"
							_g_object_unref0 (cell_tmp);
#line 1846 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 271 "../src/sudoku-view.vala"
	_g_object_unref0 (cell);
#line 1855 "sudoku-view.c"
}

static void
sudoku_view_set_value_highlighter (SudokuView* self,
                                   gint val,
                                   gboolean enabled)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	SudokuCell* cell = NULL;
	SudokuCell** _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	gint _tmp5_;
	gint _tmp6_;
	SudokuCell* _tmp7_;
	SudokuCell* _tmp8_;
#line 307 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 309 "../src/sudoku-view.vala"
	_tmp2_ = sudoku_view_get_highlighter (self);
#line 309 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_;
#line 309 "../src/sudoku-view.vala"
	if (!_tmp3_) {
#line 309 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 1885 "sudoku-view.c"
	} else {
#line 309 "../src/sudoku-view.vala"
		_tmp1_ = val == 0;
#line 1889 "sudoku-view.c"
	}
#line 309 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 309 "../src/sudoku-view.vala"
		_tmp0_ = TRUE;
#line 1895 "sudoku-view.c"
	} else {
#line 309 "../src/sudoku-view.vala"
		_tmp0_ = !self->highlight_numbers;
#line 1899 "sudoku-view.c"
	}
#line 309 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 310 "../src/sudoku-view.vala"
		return;
#line 1905 "sudoku-view.c"
	}
#line 312 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->cells;
#line 312 "../src/sudoku-view.vala"
	_tmp4__length1 = self->priv->cells_length1;
#line 312 "../src/sudoku-view.vala"
	_tmp4__length2 = self->priv->cells_length2;
#line 312 "../src/sudoku-view.vala"
	_tmp5_ = self->priv->_selected_row;
#line 312 "../src/sudoku-view.vala"
	_tmp6_ = self->priv->_selected_col;
#line 312 "../src/sudoku-view.vala"
	_tmp7_ = _tmp4_[(_tmp5_ * _tmp4__length2) + _tmp6_];
#line 312 "../src/sudoku-view.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 312 "../src/sudoku-view.vala"
	cell = _tmp8_;
#line 1923 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 314 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 1928 "sudoku-view.c"
		{
			gboolean _tmp9_ = FALSE;
#line 314 "../src/sudoku-view.vala"
			_tmp9_ = TRUE;
#line 314 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1935 "sudoku-view.c"
				SudokuGame* _tmp11_;
				SudokuBoard* _tmp12_;
				SudokuBoard* _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
#line 314 "../src/sudoku-view.vala"
				if (!_tmp9_) {
#line 1943 "sudoku-view.c"
					gint _tmp10_;
#line 314 "../src/sudoku-view.vala"
					_tmp10_ = col_tmp;
#line 314 "../src/sudoku-view.vala"
					col_tmp = _tmp10_ + 1;
#line 1949 "sudoku-view.c"
				}
#line 314 "../src/sudoku-view.vala"
				_tmp9_ = FALSE;
#line 314 "../src/sudoku-view.vala"
				_tmp11_ = self->priv->game;
#line 314 "../src/sudoku-view.vala"
				_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 314 "../src/sudoku-view.vala"
				_tmp13_ = _tmp12_;
#line 314 "../src/sudoku-view.vala"
				_tmp14_ = sudoku_board_get_cols (_tmp13_);
#line 314 "../src/sudoku-view.vala"
				_tmp15_ = _tmp14_;
#line 314 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp15_)) {
#line 314 "../src/sudoku-view.vala"
					break;
#line 1967 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 316 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 1973 "sudoku-view.c"
					{
						gboolean _tmp16_ = FALSE;
#line 316 "../src/sudoku-view.vala"
						_tmp16_ = TRUE;
#line 316 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1980 "sudoku-view.c"
							SudokuGame* _tmp18_;
							SudokuBoard* _tmp19_;
							SudokuBoard* _tmp20_;
							gint _tmp21_;
							gint _tmp22_;
							SudokuCell* cell_tmp = NULL;
							SudokuCell** _tmp23_;
							gint _tmp23__length1;
							gint _tmp23__length2;
							SudokuCell* _tmp24_;
							SudokuCell* _tmp25_;
							SudokuCell* _tmp26_;
							SudokuCell* _tmp27_;
							SudokuCell* _tmp28_;
							gint _tmp29_;
							gint _tmp30_;
#line 316 "../src/sudoku-view.vala"
							if (!_tmp16_) {
#line 1999 "sudoku-view.c"
								gint _tmp17_;
#line 316 "../src/sudoku-view.vala"
								_tmp17_ = row_tmp;
#line 316 "../src/sudoku-view.vala"
								row_tmp = _tmp17_ + 1;
#line 2005 "sudoku-view.c"
							}
#line 316 "../src/sudoku-view.vala"
							_tmp16_ = FALSE;
#line 316 "../src/sudoku-view.vala"
							_tmp18_ = self->priv->game;
#line 316 "../src/sudoku-view.vala"
							_tmp19_ = sudoku_game_get_board (_tmp18_);
#line 316 "../src/sudoku-view.vala"
							_tmp20_ = _tmp19_;
#line 316 "../src/sudoku-view.vala"
							_tmp21_ = sudoku_board_get_rows (_tmp20_);
#line 316 "../src/sudoku-view.vala"
							_tmp22_ = _tmp21_;
#line 316 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp22_)) {
#line 316 "../src/sudoku-view.vala"
								break;
#line 2023 "sudoku-view.c"
							}
#line 318 "../src/sudoku-view.vala"
							_tmp23_ = self->priv->cells;
#line 318 "../src/sudoku-view.vala"
							_tmp23__length1 = self->priv->cells_length1;
#line 318 "../src/sudoku-view.vala"
							_tmp23__length2 = self->priv->cells_length2;
#line 318 "../src/sudoku-view.vala"
							_tmp24_ = _tmp23_[(row_tmp * _tmp23__length2) + col_tmp];
#line 318 "../src/sudoku-view.vala"
							_tmp25_ = _g_object_ref0 (_tmp24_);
#line 318 "../src/sudoku-view.vala"
							cell_tmp = _tmp25_;
#line 320 "../src/sudoku-view.vala"
							_tmp26_ = cell;
#line 320 "../src/sudoku-view.vala"
							_tmp27_ = cell_tmp;
#line 320 "../src/sudoku-view.vala"
							if (_tmp26_ == _tmp27_) {
#line 321 "../src/sudoku-view.vala"
								_g_object_unref0 (cell_tmp);
#line 321 "../src/sudoku-view.vala"
								continue;
#line 2047 "sudoku-view.c"
							}
#line 323 "../src/sudoku-view.vala"
							_tmp28_ = cell_tmp;
#line 323 "../src/sudoku-view.vala"
							_tmp29_ = sudoku_cell_get_value (_tmp28_);
#line 323 "../src/sudoku-view.vala"
							_tmp30_ = _tmp29_;
#line 323 "../src/sudoku-view.vala"
							if (val == _tmp30_) {
#line 2057 "sudoku-view.c"
								SudokuCell* _tmp31_;
#line 324 "../src/sudoku-view.vala"
								_tmp31_ = cell_tmp;
#line 324 "../src/sudoku-view.vala"
								sudoku_cell_set_highlighted_value (_tmp31_, enabled);
#line 2063 "sudoku-view.c"
							} else {
								SudokuCell* _tmp32_;
								gint _tmp33_;
								gint _tmp34_;
#line 325 "../src/sudoku-view.vala"
								_tmp32_ = cell_tmp;
#line 325 "../src/sudoku-view.vala"
								_tmp33_ = sudoku_cell_get_value (_tmp32_);
#line 325 "../src/sudoku-view.vala"
								_tmp34_ = _tmp33_;
#line 325 "../src/sudoku-view.vala"
								if (_tmp34_ == 0) {
#line 2076 "sudoku-view.c"
									SudokuCell* _tmp35_;
#line 326 "../src/sudoku-view.vala"
									_tmp35_ = cell_tmp;
#line 326 "../src/sudoku-view.vala"
									sudoku_cell_set_earmark_highlight (_tmp35_, val, enabled);
#line 2082 "sudoku-view.c"
								}
							}
#line 316 "../src/sudoku-view.vala"
							_g_object_unref0 (cell_tmp);
#line 2087 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 307 "../src/sudoku-view.vala"
	_g_object_unref0 (cell);
#line 2096 "sudoku-view.c"
}

static void
sudoku_view_update_warnings (SudokuView* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 331 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 333 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_view_get_show_warnings (self);
#line 333 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 333 "../src/sudoku-view.vala"
	if (!_tmp1_) {
#line 334 "../src/sudoku-view.vala"
		return;
#line 2114 "sudoku-view.c"
	}
	{
		gint col = 0;
#line 336 "../src/sudoku-view.vala"
		col = 0;
#line 2120 "sudoku-view.c"
		{
			gboolean _tmp2_ = FALSE;
#line 336 "../src/sudoku-view.vala"
			_tmp2_ = TRUE;
#line 336 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2127 "sudoku-view.c"
				SudokuGame* _tmp4_;
				SudokuBoard* _tmp5_;
				SudokuBoard* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 336 "../src/sudoku-view.vala"
				if (!_tmp2_) {
#line 2135 "sudoku-view.c"
					gint _tmp3_;
#line 336 "../src/sudoku-view.vala"
					_tmp3_ = col;
#line 336 "../src/sudoku-view.vala"
					col = _tmp3_ + 1;
#line 2141 "sudoku-view.c"
				}
#line 336 "../src/sudoku-view.vala"
				_tmp2_ = FALSE;
#line 336 "../src/sudoku-view.vala"
				_tmp4_ = self->priv->game;
#line 336 "../src/sudoku-view.vala"
				_tmp5_ = sudoku_game_get_board (_tmp4_);
#line 336 "../src/sudoku-view.vala"
				_tmp6_ = _tmp5_;
#line 336 "../src/sudoku-view.vala"
				_tmp7_ = sudoku_board_get_cols (_tmp6_);
#line 336 "../src/sudoku-view.vala"
				_tmp8_ = _tmp7_;
#line 336 "../src/sudoku-view.vala"
				if (!(col < _tmp8_)) {
#line 336 "../src/sudoku-view.vala"
					break;
#line 2159 "sudoku-view.c"
				}
				{
					gint row = 0;
#line 337 "../src/sudoku-view.vala"
					row = 0;
#line 2165 "sudoku-view.c"
					{
						gboolean _tmp9_ = FALSE;
#line 337 "../src/sudoku-view.vala"
						_tmp9_ = TRUE;
#line 337 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2172 "sudoku-view.c"
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuCell** _tmp16_;
							gint _tmp16__length1;
							gint _tmp16__length2;
							SudokuCell* _tmp17_;
							SudokuCell** _tmp18_;
							gint _tmp18__length1;
							gint _tmp18__length2;
							SudokuCell* _tmp19_;
#line 337 "../src/sudoku-view.vala"
							if (!_tmp9_) {
#line 2188 "sudoku-view.c"
								gint _tmp10_;
#line 337 "../src/sudoku-view.vala"
								_tmp10_ = row;
#line 337 "../src/sudoku-view.vala"
								row = _tmp10_ + 1;
#line 2194 "sudoku-view.c"
							}
#line 337 "../src/sudoku-view.vala"
							_tmp9_ = FALSE;
#line 337 "../src/sudoku-view.vala"
							_tmp11_ = self->priv->game;
#line 337 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 337 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 337 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_board_get_rows (_tmp13_);
#line 337 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 337 "../src/sudoku-view.vala"
							if (!(row < _tmp15_)) {
#line 337 "../src/sudoku-view.vala"
								break;
#line 2212 "sudoku-view.c"
							}
#line 339 "../src/sudoku-view.vala"
							_tmp16_ = self->priv->cells;
#line 339 "../src/sudoku-view.vala"
							_tmp16__length1 = self->priv->cells_length1;
#line 339 "../src/sudoku-view.vala"
							_tmp16__length2 = self->priv->cells_length2;
#line 339 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_[(row * _tmp16__length2) + col];
#line 339 "../src/sudoku-view.vala"
							sudoku_cell_check_value_warnings (_tmp17_);
#line 340 "../src/sudoku-view.vala"
							_tmp18_ = self->priv->cells;
#line 340 "../src/sudoku-view.vala"
							_tmp18__length1 = self->priv->cells_length1;
#line 340 "../src/sudoku-view.vala"
							_tmp18__length2 = self->priv->cells_length2;
#line 340 "../src/sudoku-view.vala"
							_tmp19_ = _tmp18_[(row * _tmp18__length2) + col];
#line 340 "../src/sudoku-view.vala"
							sudoku_cell_check_earmarks_warnings (_tmp19_);
#line 2234 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_clear_all_warnings (SudokuView* self)
{
#line 344 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 2248 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 346 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 2253 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 346 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 346 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2260 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				SudokuBoard* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 346 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2268 "sudoku-view.c"
					gint _tmp1_;
#line 346 "../src/sudoku-view.vala"
					_tmp1_ = col_tmp;
#line 346 "../src/sudoku-view.vala"
					col_tmp = _tmp1_ + 1;
#line 2274 "sudoku-view.c"
				}
#line 346 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 346 "../src/sudoku-view.vala"
				_tmp2_ = self->priv->game;
#line 346 "../src/sudoku-view.vala"
				_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 346 "../src/sudoku-view.vala"
				_tmp4_ = _tmp3_;
#line 346 "../src/sudoku-view.vala"
				_tmp5_ = sudoku_board_get_cols (_tmp4_);
#line 346 "../src/sudoku-view.vala"
				_tmp6_ = _tmp5_;
#line 346 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp6_)) {
#line 346 "../src/sudoku-view.vala"
					break;
#line 2292 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 347 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 2298 "sudoku-view.c"
					{
						gboolean _tmp7_ = FALSE;
#line 347 "../src/sudoku-view.vala"
						_tmp7_ = TRUE;
#line 347 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2305 "sudoku-view.c"
							SudokuGame* _tmp9_;
							SudokuBoard* _tmp10_;
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							SudokuCell** _tmp14_;
							gint _tmp14__length1;
							gint _tmp14__length2;
							SudokuCell* _tmp15_;
#line 347 "../src/sudoku-view.vala"
							if (!_tmp7_) {
#line 2317 "sudoku-view.c"
								gint _tmp8_;
#line 347 "../src/sudoku-view.vala"
								_tmp8_ = row_tmp;
#line 347 "../src/sudoku-view.vala"
								row_tmp = _tmp8_ + 1;
#line 2323 "sudoku-view.c"
							}
#line 347 "../src/sudoku-view.vala"
							_tmp7_ = FALSE;
#line 347 "../src/sudoku-view.vala"
							_tmp9_ = self->priv->game;
#line 347 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 347 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 347 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_board_get_rows (_tmp11_);
#line 347 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 347 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp13_)) {
#line 347 "../src/sudoku-view.vala"
								break;
#line 2341 "sudoku-view.c"
							}
#line 348 "../src/sudoku-view.vala"
							_tmp14_ = self->priv->cells;
#line 348 "../src/sudoku-view.vala"
							_tmp14__length1 = self->priv->cells_length1;
#line 348 "../src/sudoku-view.vala"
							_tmp14__length2 = self->priv->cells_length2;
#line 348 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_[(row_tmp * _tmp14__length2) + col_tmp];
#line 348 "../src/sudoku-view.vala"
							sudoku_cell_clear_warnings (_tmp15_);
#line 2353 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_mask_view (SudokuView* self)
{
#line 351 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 2367 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 353 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 2372 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 353 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 353 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2379 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				SudokuBoard* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 353 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2387 "sudoku-view.c"
					gint _tmp1_;
#line 353 "../src/sudoku-view.vala"
					_tmp1_ = col_tmp;
#line 353 "../src/sudoku-view.vala"
					col_tmp = _tmp1_ + 1;
#line 2393 "sudoku-view.c"
				}
#line 353 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 353 "../src/sudoku-view.vala"
				_tmp2_ = self->priv->game;
#line 353 "../src/sudoku-view.vala"
				_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 353 "../src/sudoku-view.vala"
				_tmp4_ = _tmp3_;
#line 353 "../src/sudoku-view.vala"
				_tmp5_ = sudoku_board_get_cols (_tmp4_);
#line 353 "../src/sudoku-view.vala"
				_tmp6_ = _tmp5_;
#line 353 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp6_)) {
#line 353 "../src/sudoku-view.vala"
					break;
#line 2411 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 354 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 2417 "sudoku-view.c"
					{
						gboolean _tmp7_ = FALSE;
#line 354 "../src/sudoku-view.vala"
						_tmp7_ = TRUE;
#line 354 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2424 "sudoku-view.c"
							SudokuGame* _tmp9_;
							SudokuBoard* _tmp10_;
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							SudokuCell** _tmp14_;
							gint _tmp14__length1;
							gint _tmp14__length2;
							SudokuCell* _tmp15_;
#line 354 "../src/sudoku-view.vala"
							if (!_tmp7_) {
#line 2436 "sudoku-view.c"
								gint _tmp8_;
#line 354 "../src/sudoku-view.vala"
								_tmp8_ = row_tmp;
#line 354 "../src/sudoku-view.vala"
								row_tmp = _tmp8_ + 1;
#line 2442 "sudoku-view.c"
							}
#line 354 "../src/sudoku-view.vala"
							_tmp7_ = FALSE;
#line 354 "../src/sudoku-view.vala"
							_tmp9_ = self->priv->game;
#line 354 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 354 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 354 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_board_get_rows (_tmp11_);
#line 354 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 354 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp13_)) {
#line 354 "../src/sudoku-view.vala"
								break;
#line 2460 "sudoku-view.c"
							}
#line 355 "../src/sudoku-view.vala"
							_tmp14_ = self->priv->cells;
#line 355 "../src/sudoku-view.vala"
							_tmp14__length1 = self->priv->cells_length1;
#line 355 "../src/sudoku-view.vala"
							_tmp14__length2 = self->priv->cells_length2;
#line 355 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_[(row_tmp * _tmp14__length2) + col_tmp];
#line 355 "../src/sudoku-view.vala"
							sudoku_cell_set_paused (_tmp15_, TRUE);
#line 2472 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_unmask_view (SudokuView* self)
{
#line 358 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 2486 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 360 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 2491 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 360 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 360 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2498 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				SudokuBoard* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 360 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2506 "sudoku-view.c"
					gint _tmp1_;
#line 360 "../src/sudoku-view.vala"
					_tmp1_ = col_tmp;
#line 360 "../src/sudoku-view.vala"
					col_tmp = _tmp1_ + 1;
#line 2512 "sudoku-view.c"
				}
#line 360 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 360 "../src/sudoku-view.vala"
				_tmp2_ = self->priv->game;
#line 360 "../src/sudoku-view.vala"
				_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 360 "../src/sudoku-view.vala"
				_tmp4_ = _tmp3_;
#line 360 "../src/sudoku-view.vala"
				_tmp5_ = sudoku_board_get_cols (_tmp4_);
#line 360 "../src/sudoku-view.vala"
				_tmp6_ = _tmp5_;
#line 360 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp6_)) {
#line 360 "../src/sudoku-view.vala"
					break;
#line 2530 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 361 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 2536 "sudoku-view.c"
					{
						gboolean _tmp7_ = FALSE;
#line 361 "../src/sudoku-view.vala"
						_tmp7_ = TRUE;
#line 361 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2543 "sudoku-view.c"
							SudokuGame* _tmp9_;
							SudokuBoard* _tmp10_;
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							SudokuCell** _tmp14_;
							gint _tmp14__length1;
							gint _tmp14__length2;
							SudokuCell* _tmp15_;
#line 361 "../src/sudoku-view.vala"
							if (!_tmp7_) {
#line 2555 "sudoku-view.c"
								gint _tmp8_;
#line 361 "../src/sudoku-view.vala"
								_tmp8_ = row_tmp;
#line 361 "../src/sudoku-view.vala"
								row_tmp = _tmp8_ + 1;
#line 2561 "sudoku-view.c"
							}
#line 361 "../src/sudoku-view.vala"
							_tmp7_ = FALSE;
#line 361 "../src/sudoku-view.vala"
							_tmp9_ = self->priv->game;
#line 361 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 361 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 361 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_board_get_rows (_tmp11_);
#line 361 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 361 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp13_)) {
#line 361 "../src/sudoku-view.vala"
								break;
#line 2579 "sudoku-view.c"
							}
#line 362 "../src/sudoku-view.vala"
							_tmp14_ = self->priv->cells;
#line 362 "../src/sudoku-view.vala"
							_tmp14__length1 = self->priv->cells_length1;
#line 362 "../src/sudoku-view.vala"
							_tmp14__length2 = self->priv->cells_length2;
#line 362 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_[(row_tmp * _tmp14__length2) + col_tmp];
#line 362 "../src/sudoku-view.vala"
							sudoku_cell_set_paused (_tmp15_, FALSE);
#line 2591 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

void
sudoku_view_dismiss_popovers (SudokuView* self)
{
#line 442 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 2605 "sudoku-view.c"
	{
		gint i = 0;
#line 444 "../src/sudoku-view.vala"
		i = 0;
#line 2610 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 444 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 444 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2617 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				SudokuBoard* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 444 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2625 "sudoku-view.c"
					gint _tmp1_;
#line 444 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 444 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 2631 "sudoku-view.c"
				}
#line 444 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 444 "../src/sudoku-view.vala"
				_tmp2_ = self->priv->game;
#line 444 "../src/sudoku-view.vala"
				_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 444 "../src/sudoku-view.vala"
				_tmp4_ = _tmp3_;
#line 444 "../src/sudoku-view.vala"
				_tmp5_ = sudoku_board_get_rows (_tmp4_);
#line 444 "../src/sudoku-view.vala"
				_tmp6_ = _tmp5_;
#line 444 "../src/sudoku-view.vala"
				if (!(i < _tmp6_)) {
#line 444 "../src/sudoku-view.vala"
					break;
#line 2649 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 445 "../src/sudoku-view.vala"
					j = 0;
#line 2655 "sudoku-view.c"
					{
						gboolean _tmp7_ = FALSE;
#line 445 "../src/sudoku-view.vala"
						_tmp7_ = TRUE;
#line 445 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2662 "sudoku-view.c"
							SudokuGame* _tmp9_;
							SudokuBoard* _tmp10_;
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							SudokuCell** _tmp14_;
							gint _tmp14__length1;
							gint _tmp14__length2;
							SudokuCell* _tmp15_;
#line 445 "../src/sudoku-view.vala"
							if (!_tmp7_) {
#line 2674 "sudoku-view.c"
								gint _tmp8_;
#line 445 "../src/sudoku-view.vala"
								_tmp8_ = j;
#line 445 "../src/sudoku-view.vala"
								j = _tmp8_ + 1;
#line 2680 "sudoku-view.c"
							}
#line 445 "../src/sudoku-view.vala"
							_tmp7_ = FALSE;
#line 445 "../src/sudoku-view.vala"
							_tmp9_ = self->priv->game;
#line 445 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 445 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 445 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_board_get_cols (_tmp11_);
#line 445 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 445 "../src/sudoku-view.vala"
							if (!(j < _tmp13_)) {
#line 445 "../src/sudoku-view.vala"
								break;
#line 2698 "sudoku-view.c"
							}
#line 446 "../src/sudoku-view.vala"
							_tmp14_ = self->priv->cells;
#line 446 "../src/sudoku-view.vala"
							_tmp14__length1 = self->priv->cells_length1;
#line 446 "../src/sudoku-view.vala"
							_tmp14__length2 = self->priv->cells_length2;
#line 446 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_[(i * _tmp14__length2) + j];
#line 446 "../src/sudoku-view.vala"
							sudoku_cell_dismiss_popover (_tmp15_);
#line 2710 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_real_dispose (GObject* base)
{
	SudokuView * self;
	SudokuFrame* _tmp0_;
#line 449 "../src/sudoku-view.vala"
	self = (SudokuView*) base;
#line 451 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->frame;
#line 451 "../src/sudoku-view.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
#line 452 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (sudoku_view_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_bin_get_type (), AdwBin));
#line 2732 "sudoku-view.c"
}

gint
sudoku_view_get_selected_row (SudokuView* self)
{
	gint result;
#line 40 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 40 "../src/sudoku-view.vala"
	result = self->priv->_selected_row;
#line 40 "../src/sudoku-view.vala"
	return result;
#line 2745 "sudoku-view.c"
}

static void
sudoku_view_set_selected_row (SudokuView* self,
                              gint value)
{
	gint old_value;
#line 40 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/sudoku-view.vala"
	old_value = sudoku_view_get_selected_row (self);
#line 40 "../src/sudoku-view.vala"
	if (old_value != value) {
#line 40 "../src/sudoku-view.vala"
		self->priv->_selected_row = value;
#line 40 "../src/sudoku-view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SELECTED_ROW_PROPERTY]);
#line 2763 "sudoku-view.c"
	}
}

gint
sudoku_view_get_selected_col (SudokuView* self)
{
	gint result;
#line 41 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 41 "../src/sudoku-view.vala"
	result = self->priv->_selected_col;
#line 41 "../src/sudoku-view.vala"
	return result;
#line 2777 "sudoku-view.c"
}

static void
sudoku_view_set_selected_col (SudokuView* self,
                              gint value)
{
	gint old_value;
#line 41 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/sudoku-view.vala"
	old_value = sudoku_view_get_selected_col (self);
#line 41 "../src/sudoku-view.vala"
	if (old_value != value) {
#line 41 "../src/sudoku-view.vala"
		self->priv->_selected_col = value;
#line 41 "../src/sudoku-view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SELECTED_COL_PROPERTY]);
#line 2795 "sudoku-view.c"
	}
}

gboolean
sudoku_view_get_show_warnings (SudokuView* self)
{
	gboolean result;
#line 368 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 368 "../src/sudoku-view.vala"
	result = self->priv->_show_warnings;
#line 368 "../src/sudoku-view.vala"
	return result;
#line 2809 "sudoku-view.c"
}

void
sudoku_view_set_show_warnings (SudokuView* self,
                               gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 369 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 370 "../src/sudoku-view.vala"
	self->priv->_show_warnings = value;
#line 372 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_view_get_show_warnings (self);
#line 372 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 372 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 373 "../src/sudoku-view.vala"
		sudoku_view_update_warnings (self);
#line 2832 "sudoku-view.c"
	} else {
#line 375 "../src/sudoku-view.vala"
		sudoku_view_clear_all_warnings (self);
#line 2836 "sudoku-view.c"
	}
#line 377 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->_selected_row;
#line 377 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->_selected_col;
#line 377 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp2_, _tmp3_, TRUE);
#line 369 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY]);
#line 2846 "sudoku-view.c"
}

gboolean
sudoku_view_get_show_earmark_warnings (SudokuView* self)
{
	gboolean result;
#line 384 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 384 "../src/sudoku-view.vala"
	result = self->priv->_show_earmark_warnings;
#line 384 "../src/sudoku-view.vala"
	return result;
#line 2859 "sudoku-view.c"
}

void
sudoku_view_set_show_earmark_warnings (SudokuView* self,
                                       gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 385 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 386 "../src/sudoku-view.vala"
	self->priv->_show_earmark_warnings = value;
#line 387 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_view_get_show_warnings (self);
#line 387 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 387 "../src/sudoku-view.vala"
	sudoku_view_set_show_warnings (self, _tmp1_);
#line 385 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY]);
#line 2880 "sudoku-view.c"
}

gboolean
sudoku_view_get_simple_warnings (SudokuView* self)
{
	gboolean result;
#line 394 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 394 "../src/sudoku-view.vala"
	result = self->priv->_simple_warnings;
#line 394 "../src/sudoku-view.vala"
	return result;
#line 2893 "sudoku-view.c"
}

void
sudoku_view_set_simple_warnings (SudokuView* self,
                                 gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 395 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 396 "../src/sudoku-view.vala"
	self->priv->_simple_warnings = value;
#line 397 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_view_get_show_warnings (self);
#line 397 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 397 "../src/sudoku-view.vala"
	sudoku_view_set_show_warnings (self, _tmp1_);
#line 395 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SIMPLE_WARNINGS_PROPERTY]);
#line 2914 "sudoku-view.c"
}

gboolean
sudoku_view_get_show_possibilities (SudokuView* self)
{
	gboolean result;
#line 404 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 404 "../src/sudoku-view.vala"
	result = self->priv->_show_possibilities;
#line 404 "../src/sudoku-view.vala"
	return result;
#line 2927 "sudoku-view.c"
}

void
sudoku_view_set_show_possibilities (SudokuView* self,
                                    gboolean value)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 405 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 406 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = value;
#line 407 "../src/sudoku-view.vala"
	_tmp1_ = sudoku_view_get_show_possibilities (self);
#line 407 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_;
#line 407 "../src/sudoku-view.vala"
	if (_tmp2_) {
#line 2947 "sudoku-view.c"
		SudokuGame* _tmp3_;
		GameMode _tmp4_;
		GameMode _tmp5_;
#line 407 "../src/sudoku-view.vala"
		_tmp3_ = self->priv->game;
#line 407 "../src/sudoku-view.vala"
		_tmp4_ = sudoku_game_get_mode (_tmp3_);
#line 407 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_;
#line 407 "../src/sudoku-view.vala"
		_tmp0_ = _tmp5_ != GAME_MODE_CREATE;
#line 2959 "sudoku-view.c"
	} else {
#line 407 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 2963 "sudoku-view.c"
	}
#line 407 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 2967 "sudoku-view.c"
		SudokuGame* _tmp6_;
#line 408 "../src/sudoku-view.vala"
		_tmp6_ = self->priv->game;
#line 408 "../src/sudoku-view.vala"
		sudoku_game_enable_all_earmark_possibilities (_tmp6_);
#line 2973 "sudoku-view.c"
	} else {
		SudokuGame* _tmp7_;
#line 409 "../src/sudoku-view.vala"
		_tmp7_ = self->priv->game;
#line 409 "../src/sudoku-view.vala"
		if (sudoku_game_get_current_stack_action (_tmp7_) == STACK_ACTION_ENABLE_ALL_EARMARK_POSSIBILITIES) {
#line 2980 "sudoku-view.c"
			SudokuGame* _tmp8_;
#line 410 "../src/sudoku-view.vala"
			_tmp8_ = self->priv->game;
#line 410 "../src/sudoku-view.vala"
			sudoku_game_undo (_tmp8_);
#line 2986 "sudoku-view.c"
		}
	}
#line 405 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY]);
#line 2991 "sudoku-view.c"
}

gboolean
sudoku_view_get_highlighter (SudokuView* self)
{
	gboolean result;
#line 417 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 417 "../src/sudoku-view.vala"
	result = self->priv->_highlighter;
#line 417 "../src/sudoku-view.vala"
	return result;
#line 3004 "sudoku-view.c"
}

void
sudoku_view_set_highlighter (SudokuView* self,
                             gboolean value)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 418 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 419 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->_selected_row;
#line 419 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->_selected_col;
#line 419 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp0_, _tmp1_, FALSE);
#line 420 "../src/sudoku-view.vala"
	self->priv->_highlighter = value;
#line 421 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->_selected_row;
#line 421 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->_selected_col;
#line 421 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp2_, _tmp3_, TRUE);
#line 418 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY]);
#line 3033 "sudoku-view.c"
}

gboolean
sudoku_view_get_has_selection (SudokuView* self)
{
	gboolean result;
#line 428 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 428 "../src/sudoku-view.vala"
	result = self->priv->_has_selection;
#line 428 "../src/sudoku-view.vala"
	return result;
#line 3046 "sudoku-view.c"
}

void
sudoku_view_set_has_selection (SudokuView* self,
                               gboolean value)
{
	SudokuCell* cell = NULL;
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint _tmp2_;
	SudokuCell* _tmp3_;
	SudokuCell* _tmp4_;
	SudokuCell* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	gint _tmp12_;
	gint _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
#line 429 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 430 "../src/sudoku-view.vala"
	self->priv->_has_selection = value;
#line 431 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->cells;
#line 431 "../src/sudoku-view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 431 "../src/sudoku-view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 431 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->_selected_row;
#line 431 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->_selected_col;
#line 431 "../src/sudoku-view.vala"
	_tmp3_ = _tmp0_[(_tmp1_ * _tmp0__length2) + _tmp2_];
#line 431 "../src/sudoku-view.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 431 "../src/sudoku-view.vala"
	cell = _tmp4_;
#line 432 "../src/sudoku-view.vala"
	_tmp5_ = cell;
#line 432 "../src/sudoku-view.vala"
	_tmp6_ = sudoku_view_get_has_selection (self);
#line 432 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_;
#line 432 "../src/sudoku-view.vala"
	sudoku_cell_set_selected (_tmp5_, _tmp7_);
#line 433 "../src/sudoku-view.vala"
	_tmp8_ = sudoku_view_get_has_selection (self);
#line 433 "../src/sudoku-view.vala"
	_tmp9_ = _tmp8_;
#line 433 "../src/sudoku-view.vala"
	if (_tmp9_) {
#line 3104 "sudoku-view.c"
		SudokuCell* _tmp10_;
#line 434 "../src/sudoku-view.vala"
		_tmp10_ = cell;
#line 434 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp10_);
#line 3110 "sudoku-view.c"
	} else {
		SudokuCell* _tmp11_;
#line 436 "../src/sudoku-view.vala"
		_tmp11_ = cell;
#line 436 "../src/sudoku-view.vala"
		sudoku_cell_dismiss_popover (_tmp11_);
#line 3117 "sudoku-view.c"
	}
#line 438 "../src/sudoku-view.vala"
	_tmp12_ = self->priv->_selected_row;
#line 438 "../src/sudoku-view.vala"
	_tmp13_ = self->priv->_selected_col;
#line 438 "../src/sudoku-view.vala"
	_tmp14_ = sudoku_view_get_has_selection (self);
#line 438 "../src/sudoku-view.vala"
	_tmp15_ = _tmp14_;
#line 438 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp12_, _tmp13_, _tmp15_);
#line 429 "../src/sudoku-view.vala"
	_g_object_unref0 (cell);
#line 429 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HAS_SELECTION_PROPERTY]);
#line 3133 "sudoku-view.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_INT_INT) (gpointer data1, gint arg_1, gint arg_2, gint arg_3, gint arg_4, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 26 "../src/sudoku-view.vala"
	g_return_if_fail (n_param_values == 5);
#line 26 "../src/sudoku-view.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 26 "../src/sudoku-view.vala"
		data1 = closure->data;
#line 26 "../src/sudoku-view.vala"
		data2 = param_values->data[0].v_pointer;
#line 3158 "sudoku-view.c"
	} else {
#line 26 "../src/sudoku-view.vala"
		data1 = param_values->data[0].v_pointer;
#line 26 "../src/sudoku-view.vala"
		data2 = closure->data;
#line 3164 "sudoku-view.c"
	}
#line 26 "../src/sudoku-view.vala"
	callback = (GMarshalFunc_VOID__INT_INT_INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 26 "../src/sudoku-view.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), g_value_get_int (param_values + 4), data2);
#line 3170 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda9_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	gboolean result;
#line 174 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 175 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 175 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 177 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 177 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 177 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 177 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3198 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 177 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 177 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 177 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 3208 "sudoku-view.c"
	}
#line 177 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 178 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 178 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 178 "../src/sudoku-view.vala"
		return result;
#line 3218 "sudoku-view.c"
	}
#line 180 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 180 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_row;
#line 180 "../src/sudoku-view.vala"
	if (_tmp7_ == 0) {
#line 3226 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 181 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 181 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 181 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 181 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 181 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 181 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_col;
#line 181 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(8 * _tmp9__length2) + _tmp11_];
#line 181 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 3250 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 183 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 183 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 183 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 183 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 183 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 183 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 183 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 183 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 183 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[((_tmp16_ - 1) * _tmp14__length2) + _tmp18_];
#line 183 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 3281 "sudoku-view.c"
	}
#line 185 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 185 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 185 "../src/sudoku-view.vala"
	return result;
#line 3289 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda9__gtk_shortcut_func (GtkWidget* widget,
                                            GVariant* args,
                                            gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda9_ (widget);
#line 174 "../src/sudoku-view.vala"
	return result;
#line 3301 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda10_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	gboolean result;
#line 187 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 188 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 188 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 190 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 190 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 190 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 190 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3329 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 190 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 190 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 190 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 3339 "sudoku-view.c"
	}
#line 190 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 191 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 191 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 191 "../src/sudoku-view.vala"
		return result;
#line 3349 "sudoku-view.c"
	}
#line 193 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 193 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_row;
#line 193 "../src/sudoku-view.vala"
	if (_tmp7_ == 8) {
#line 3357 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 194 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 194 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 194 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 194 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 194 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 194 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_col;
#line 194 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(0 * _tmp9__length2) + _tmp11_];
#line 194 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 3381 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 196 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 196 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 196 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 196 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 196 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 196 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 196 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 196 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 196 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[((_tmp16_ + 1) * _tmp14__length2) + _tmp18_];
#line 196 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 3412 "sudoku-view.c"
	}
#line 198 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 198 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 198 "../src/sudoku-view.vala"
	return result;
#line 3420 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda10__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda10_ (widget);
#line 187 "../src/sudoku-view.vala"
	return result;
#line 3432 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda11_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	gboolean result;
#line 200 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 201 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 201 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 203 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 203 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 203 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 203 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3460 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 203 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 203 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 203 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 3470 "sudoku-view.c"
	}
#line 203 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 204 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 204 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 204 "../src/sudoku-view.vala"
		return result;
#line 3480 "sudoku-view.c"
	}
#line 206 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 206 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_col;
#line 206 "../src/sudoku-view.vala"
	if (_tmp7_ == 0) {
#line 3488 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 207 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 207 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 207 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 207 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 207 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 207 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_row;
#line 207 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(_tmp11_ * _tmp9__length2) + 8];
#line 207 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 3512 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 209 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 209 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 209 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 209 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 209 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 209 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 209 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 209 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 209 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[(_tmp16_ * _tmp14__length2) + (_tmp18_ - 1)];
#line 209 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 3543 "sudoku-view.c"
	}
#line 211 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 211 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 211 "../src/sudoku-view.vala"
	return result;
#line 3551 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda11__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda11_ (widget);
#line 200 "../src/sudoku-view.vala"
	return result;
#line 3563 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda12_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	gboolean result;
#line 213 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 214 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 214 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 216 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 216 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 216 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 216 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3591 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 216 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 216 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 216 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 3601 "sudoku-view.c"
	}
#line 216 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 217 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 217 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 217 "../src/sudoku-view.vala"
		return result;
#line 3611 "sudoku-view.c"
	}
#line 219 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 219 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_col;
#line 219 "../src/sudoku-view.vala"
	if (_tmp7_ == 8) {
#line 3619 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 220 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 220 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 220 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 220 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 220 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 220 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_row;
#line 220 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(_tmp11_ * _tmp9__length2) + 0];
#line 220 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 3643 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 222 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 222 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 222 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 222 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 222 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 222 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 222 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 222 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 222 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[(_tmp16_ * _tmp14__length2) + (_tmp18_ + 1)];
#line 222 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 3674 "sudoku-view.c"
	}
#line 224 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 224 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 224 "../src/sudoku-view.vala"
	return result;
#line 3682 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda12__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda12_ (widget);
#line 213 "../src/sudoku-view.vala"
	return result;
#line 3694 "sudoku-view.c"
}

static void
sudoku_view_class_init (SudokuViewClass * klass,
                        gpointer klass_data)
{
	GtkShortcutFunc up_func = NULL;
	gpointer up_func_target;
	GDestroyNotify up_func_target_destroy_notify;
	GtkShortcutFunc down_func = NULL;
	gpointer down_func_target;
	GDestroyNotify down_func_target_destroy_notify;
	GtkShortcutFunc left_func = NULL;
	gpointer left_func_target;
	GDestroyNotify left_func_target_destroy_notify;
	GtkShortcutFunc right_func = NULL;
	gpointer right_func_target;
	GDestroyNotify right_func_target_destroy_notify;
	GtkShortcutFunc _tmp0_;
	gpointer _tmp0__target;
	GtkShortcutFunc _tmp1_;
	gpointer _tmp1__target;
	GtkShortcutFunc _tmp2_;
	gpointer _tmp2__target;
	GtkShortcutFunc _tmp3_;
	gpointer _tmp3__target;
	GtkShortcutFunc _tmp4_;
	gpointer _tmp4__target;
	GtkShortcutFunc _tmp5_;
	gpointer _tmp5__target;
	GtkShortcutFunc _tmp6_;
	gpointer _tmp6__target;
	GtkShortcutFunc _tmp7_;
	gpointer _tmp7__target;
	GtkShortcutFunc _tmp8_;
	gpointer _tmp8__target;
	GtkShortcutFunc _tmp9_;
	gpointer _tmp9__target;
	GtkShortcutFunc _tmp10_;
	gpointer _tmp10__target;
	GtkShortcutFunc _tmp11_;
	gpointer _tmp11__target;
#line 26 "../src/sudoku-view.vala"
	sudoku_view_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/sudoku-view.vala"
	g_type_class_adjust_private_offset (klass, &SudokuView_private_offset);
#line 26 "../src/sudoku-view.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_view_real_dispose;
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_view_get_property;
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_view_set_property;
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_view_finalize;
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SELECTED_ROW_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SELECTED_ROW_PROPERTY] = g_param_spec_int ("selected-row", "selected-row", "selected-row", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SELECTED_COL_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SELECTED_COL_PROPERTY] = g_param_spec_int ("selected-col", "selected-col", "selected-col", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-earmark-warnings", "show-earmark-warnings", "show-earmark-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SIMPLE_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SIMPLE_WARNINGS_PROPERTY] = g_param_spec_boolean ("simple-warnings", "simple-warnings", "simple-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY] = g_param_spec_boolean ("show-possibilities", "show-possibilities", "show-possibilities", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HIGHLIGHTER_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY] = g_param_spec_boolean ("highlighter", "highlighter", "highlighter", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HAS_SELECTION_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HAS_SELECTION_PROPERTY] = g_param_spec_boolean ("has-selection", "has-selection", "has-selection", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	sudoku_view_signals[SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", TYPE_SUDOKU_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_INT_INT, G_TYPE_NONE, 4, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT);
#line 174 "../src/sudoku-view.vala"
	up_func = __sudoku_view___lambda9__gtk_shortcut_func;
#line 174 "../src/sudoku-view.vala"
	up_func_target = NULL;
#line 174 "../src/sudoku-view.vala"
	up_func_target_destroy_notify = NULL;
#line 187 "../src/sudoku-view.vala"
	down_func = __sudoku_view___lambda10__gtk_shortcut_func;
#line 187 "../src/sudoku-view.vala"
	down_func_target = NULL;
#line 187 "../src/sudoku-view.vala"
	down_func_target_destroy_notify = NULL;
#line 200 "../src/sudoku-view.vala"
	left_func = __sudoku_view___lambda11__gtk_shortcut_func;
#line 200 "../src/sudoku-view.vala"
	left_func_target = NULL;
#line 200 "../src/sudoku-view.vala"
	left_func_target_destroy_notify = NULL;
#line 213 "../src/sudoku-view.vala"
	right_func = __sudoku_view___lambda12__gtk_shortcut_func;
#line 213 "../src/sudoku-view.vala"
	right_func_target = NULL;
#line 213 "../src/sudoku-view.vala"
	right_func_target_destroy_notify = NULL;
#line 227 "../src/sudoku-view.vala"
	_tmp0_ = up_func;
#line 227 "../src/sudoku-view.vala"
	_tmp0__target = up_func_target;
#line 227 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Up, 0, _tmp0_, _tmp0__target, NULL, NULL);
#line 228 "../src/sudoku-view.vala"
	_tmp1_ = up_func;
#line 228 "../src/sudoku-view.vala"
	_tmp1__target = up_func_target;
#line 228 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Up, 0, _tmp1_, _tmp1__target, NULL, NULL);
#line 229 "../src/sudoku-view.vala"
	_tmp2_ = up_func;
#line 229 "../src/sudoku-view.vala"
	_tmp2__target = up_func_target;
#line 229 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_w, 0, _tmp2_, _tmp2__target, NULL, NULL);
#line 230 "../src/sudoku-view.vala"
	_tmp3_ = down_func;
#line 230 "../src/sudoku-view.vala"
	_tmp3__target = down_func_target;
#line 230 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Down, 0, _tmp3_, _tmp3__target, NULL, NULL);
#line 231 "../src/sudoku-view.vala"
	_tmp4_ = down_func;
#line 231 "../src/sudoku-view.vala"
	_tmp4__target = down_func_target;
#line 231 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Down, 0, _tmp4_, _tmp4__target, NULL, NULL);
#line 232 "../src/sudoku-view.vala"
	_tmp5_ = down_func;
#line 232 "../src/sudoku-view.vala"
	_tmp5__target = down_func_target;
#line 232 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_s, 0, _tmp5_, _tmp5__target, NULL, NULL);
#line 233 "../src/sudoku-view.vala"
	_tmp6_ = left_func;
#line 233 "../src/sudoku-view.vala"
	_tmp6__target = left_func_target;
#line 233 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Left, 0, _tmp6_, _tmp6__target, NULL, NULL);
#line 234 "../src/sudoku-view.vala"
	_tmp7_ = left_func;
#line 234 "../src/sudoku-view.vala"
	_tmp7__target = left_func_target;
#line 234 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Left, 0, _tmp7_, _tmp7__target, NULL, NULL);
#line 235 "../src/sudoku-view.vala"
	_tmp8_ = left_func;
#line 235 "../src/sudoku-view.vala"
	_tmp8__target = left_func_target;
#line 235 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_a, 0, _tmp8_, _tmp8__target, NULL, NULL);
#line 236 "../src/sudoku-view.vala"
	_tmp9_ = right_func;
#line 236 "../src/sudoku-view.vala"
	_tmp9__target = right_func_target;
#line 236 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Right, 0, _tmp9_, _tmp9__target, NULL, NULL);
#line 237 "../src/sudoku-view.vala"
	_tmp10_ = right_func;
#line 237 "../src/sudoku-view.vala"
	_tmp10__target = right_func_target;
#line 237 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Right, 0, _tmp10_, _tmp10__target, NULL, NULL);
#line 238 "../src/sudoku-view.vala"
	_tmp11_ = right_func;
#line 238 "../src/sudoku-view.vala"
	_tmp11__target = right_func_target;
#line 238 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_d, 0, _tmp11_, _tmp11__target, NULL, NULL);
#line 173 "../src/sudoku-view.vala"
	(right_func_target_destroy_notify == NULL) ? NULL : (right_func_target_destroy_notify (right_func_target), NULL);
#line 173 "../src/sudoku-view.vala"
	right_func = NULL;
#line 173 "../src/sudoku-view.vala"
	right_func_target = NULL;
#line 173 "../src/sudoku-view.vala"
	right_func_target_destroy_notify = NULL;
#line 173 "../src/sudoku-view.vala"
	(left_func_target_destroy_notify == NULL) ? NULL : (left_func_target_destroy_notify (left_func_target), NULL);
#line 173 "../src/sudoku-view.vala"
	left_func = NULL;
#line 173 "../src/sudoku-view.vala"
	left_func_target = NULL;
#line 173 "../src/sudoku-view.vala"
	left_func_target_destroy_notify = NULL;
#line 173 "../src/sudoku-view.vala"
	(down_func_target_destroy_notify == NULL) ? NULL : (down_func_target_destroy_notify (down_func_target), NULL);
#line 173 "../src/sudoku-view.vala"
	down_func = NULL;
#line 173 "../src/sudoku-view.vala"
	down_func_target = NULL;
#line 173 "../src/sudoku-view.vala"
	down_func_target_destroy_notify = NULL;
#line 173 "../src/sudoku-view.vala"
	(up_func_target_destroy_notify == NULL) ? NULL : (up_func_target_destroy_notify (up_func_target), NULL);
#line 173 "../src/sudoku-view.vala"
	up_func = NULL;
#line 173 "../src/sudoku-view.vala"
	up_func_target = NULL;
#line 173 "../src/sudoku-view.vala"
	up_func_target_destroy_notify = NULL;
#line 3895 "sudoku-view.c"
}

static void
sudoku_view_instance_init (SudokuView * self,
                           gpointer klass)
{
#line 26 "../src/sudoku-view.vala"
	self->priv = sudoku_view_get_instance_private (self);
#line 33 "../src/sudoku-view.vala"
	self->earmark_mode = FALSE;
#line 40 "../src/sudoku-view.vala"
	self->priv->_selected_row = 0;
#line 41 "../src/sudoku-view.vala"
	self->priv->_selected_col = 0;
#line 425 "../src/sudoku-view.vala"
	self->priv->_has_selection = TRUE;
#line 3912 "sudoku-view.c"
}

static void
sudoku_view_finalize (GObject * obj)
{
	SudokuView * self;
#line 26 "../src/sudoku-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_VIEW, SudokuView);
#line 28 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->game);
#line 29 "../src/sudoku-view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 30 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->frame);
#line 31 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->paused_label);
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (sudoku_view_parent_class)->finalize (obj);
#line 3931 "sudoku-view.c"
}

static GType
sudoku_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuView), 0, (GInstanceInitFunc) sudoku_view_instance_init, NULL };
	GType sudoku_view_type_id;
	sudoku_view_type_id = g_type_register_static (adw_bin_get_type (), "SudokuView", &g_define_type_info, 0);
	SudokuView_private_offset = g_type_add_instance_private (sudoku_view_type_id, sizeof (SudokuViewPrivate));
	return sudoku_view_type_id;
}

GType
sudoku_view_get_type (void)
{
	static volatile gsize sudoku_view_type_id__once = 0;
	if (g_once_init_enter (&sudoku_view_type_id__once)) {
		GType sudoku_view_type_id;
		sudoku_view_type_id = sudoku_view_get_type_once ();
		g_once_init_leave (&sudoku_view_type_id__once, sudoku_view_type_id);
	}
	return sudoku_view_type_id__once;
}

static void
_vala_sudoku_view_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 26 "../src/sudoku-view.vala"
	switch (property_id) {
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_ROW_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_int (value, sudoku_view_get_selected_row (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_COL_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_int (value, sudoku_view_get_selected_col (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_warnings (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_earmark_warnings (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SIMPLE_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_simple_warnings (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_possibilities (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_highlighter (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HAS_SELECTION_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_has_selection (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 4014 "sudoku-view.c"
		default:
#line 26 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/sudoku-view.vala"
		break;
#line 4020 "sudoku-view.c"
	}
}

static void
_vala_sudoku_view_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 26 "../src/sudoku-view.vala"
	switch (property_id) {
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_ROW_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_selected_row (self, g_value_get_int (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_COL_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_selected_col (self, g_value_get_int (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_warnings (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_earmark_warnings (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SIMPLE_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_simple_warnings (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_possibilities (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_highlighter (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HAS_SELECTION_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_has_selection (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 4082 "sudoku-view.c"
		default:
#line 26 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/sudoku-view.vala"
		break;
#line 4088 "sudoku-view.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

